(function () {
    'use strict';
    var app = angular.module('smnNg', ['ngRoute', 'ngAnimate', 'ngTouch', 'ngCookies', 'ngSanitize', 'google-maps', 'ui.bootstrap.collapse']),
        routes = [
            {when: '/', config: {templateUrl: 'assets/public/templates/greeting.html'}},
            {when: '/home', config: {templateUrl: 'assets/public/templates/home.html'}},
            {when: '/news', config: {templateUrl: 'assets/public/templates/news.html'}},
            {when: '/news/:id', config: {templateUrl: 'assets/public/templates/news.html'}}
        ],
        config =
            {modulename: 'smn', tittle: 'Smart Media News', info: 'info', success: 'success', warning: 'warning', error: 'error'};
    app.value('toastr', toastr);
    app.value('Modernizr', Modernizr);
    app.value('jQuery', jQuery);
    app.value('Math', Math);
    app.value('navigator', navigator);
    app.value('localStorage', localStorage);
    app.value('md5', md5);
    app.value('config', config);
    app.value('hotWire', {event: {rating: -1}, flag: false, scroll: false, filter: ''});
    (function is_portable_device() {
        (function (a) {
            (jQuery.browser = jQuery.browser || {}).mobile = /(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od|ad)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(a) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0, 4));
        }(navigator.userAgent || navigator.vendor || window.opera));
    }());
    app.config(['$logProvider', '$httpProvider', '$routeProvider', function ($logProvider, $httpProvider, $routeProvider) {

        $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';
        /*$httpProvider.defaults.useXDomain = true;
         delete $httpProvider.defaults.headers.common['X-Requested-With'];*/
        if ($logProvider.debugEnabled) {
            $logProvider.debugEnabled(true);
        }
        routes.forEach(function (route) {
            $routeProvider.when(route.when, route.config);
        });
        $routeProvider.otherwise({redirectTo: '/'});
    }]);
    app.run(['$rootScope', 'news_manager', 'hotWire', function ($rootScope, nm, hw) {
        var scope = $rootScope.$new(), s = false;
        function on_run() {
            hw.flag = true;
            nm.news().then(function (res) {
                if (res) {
                    hw.flag = false;
                    $rootScope.$broadcast('ready_db', function () {
                        return 1;
                    });
                }
            }, function () {
                hw.flag = false;
                $rootScope.$broadcast('ready_db', function () {
                    return 1;
                });
            });
            s = true;
        }
        scope.$on('$routeChangeStart', function (n, current) {
            if (current.$$route) {
                if (current.$$route.originalPath === '/home' && !s) {
                    on_run();
                } else if (current.$$route.originalPath === '/' && !s) {
                    on_run();
                }
            }
        });

        /*
        FOR GETTING RECO NEWS, BUT THIS THROWS INTERNAL ERROR
        nm.fetch_reco().then(function (reco) {}, function () {});
         */
    }]);
    app.factory('request_manager', ['$http', '$q', function ($http, $q) {
        function async_request(http) {
            var defer = $q.defer();
            $http({
                method: http.method,
                url: http.xurl || ('http://smartnews.idi.ntnu.no/' + http.url),
                data: http.data

            }).
                success(function (data) {
                    defer.resolve(data);

                }).
                error(function (data) {
                    defer.reject(data);
                });
            return defer.promise;
        }

        return {
            async_request: async_request
        };
    }]);

    app.factory('store_manager', ['localStorage', function (localStorage) {

        function add_raw_store(key, item) {
            if (key && item) {
                localStorage.setItem(key, item);
            }
        }

        function get_raw_store(key) {
            if (key) {
                var raw = localStorage.getItem(key);
                if (raw === null || undefined) {
                    return undefined;
                }
                return raw;
            }
        }

        function add_to_store(key, item) {
            if (key && item) {
                item = JSON.stringify(item);
                try {
                    localStorage.setItem(key, item);
                } catch (error) {
                } finally {
                    return true;
                }
                return true;
            }
            return false;
        }

        function get_from_store(key) {
            if (key) {
                var raw = localStorage.getItem(key);
                if (raw !== null) {
                    raw = JSON.parse(raw);
                    return raw;
                }
                return undefined;
            }
        }

        function remove_from_store(key) {
            if (key) {
                localStorage.removeItem(key);
            }
        }

        return {
            add_to_store: add_to_store,
            get_from_store: get_from_store,
            remove_from_store: remove_from_store,
            add_raw_store: add_raw_store,
            get_raw_store: get_raw_store
        };
    }]);
    app.factory('preferences', ['store_manager', 'jQuery', '$q', function (store_manager, jQuery, $q) {
        function set_geo(loc) {
            store_manager.add_to_store('geo', loc);
        }

        function get_geo() {
            return store_manager.get_from_store('geo');
        }

        function delete_geo(key) {
            store_manager.remove_from_store(key);
        }

        function xdelete() {
            store_manager.remove_from_store('x_pref');
        }

        function xget_pref() {
            return store_manager.get_from_store('x_pref');
        }

        function xset_pref(pref) {
            var base = xget_pref(), defer = $q.defer();
            if (base !== undefined) {
                base = jQuery.extend({}, base, pref);
                store_manager.add_to_store('x_pref', base);
                defer.resolve(true);
            } else {
                store_manager.add_to_store('x_pref', pref);
                defer.resolve(true);
            }
            return defer.promise;
        }

        function font_pref(size) {
            var o;
            switch (size) {
            case 1:
                o = '0.8';
                break;
            case 2:
                o = '0.9';
                break;
            case 3:
                    o = '1';
                    break;
            case 4:
                    o = '1.1';
                    break;
                case 5:
                    o = '1.2';
                    break;
                case 6:
                    o = '1.3';
                    break;
                case 7:
                    o = '1.4';
                    break;
                case 8:
                    o = '1.5';
                    break;
                case 9:
                    o = '1.6';
                    break;
                case 10:
                    o = '1.7';
                    break;
                case 11:
                    o = '1.8';
                    break;
                case 12:
                    o = '1.9';
                    break;
            case 13:
                o = '2';
                break;
            default:
                o = '1';
                break;
            }
            return o + 'em';
        }

        function bg_pref(p) {
            var a = [];
            switch (p) {
                case 1:
                    a.push({bc: 'rgb(253,233,235)', fc: '#333333'});
                    break;
                case 2:
                    a.push({bc: 'rgb(35,35,35)', fc: 'rgb(134, 185, 51)'});
                    break;
                case 3:
                    a.push({bc: 'rgb(241,241,241)', fc: '#333333'});
                    break;
                default:
                    a.push({bc: 'rgb(35,35,35)', fc: 'rgb(241,241,241)'});
                    break;
            }
            return a;
        }

        return {
            set_geo: set_geo,
            get_geo: get_geo,
            delete_geo: delete_geo,
            xset_pref: xset_pref,
            xget_pref: xget_pref,
            font_pref: font_pref,
            bg_pref: bg_pref
        };
    }]);
    app.factory('animation', ['jQuery', function (jQuery) {

        function toggle(elem, addition, size) {
            size = size || 2;
            addition = addition || '<i class="fa fa-' + size + 'x fa-spinner fa-spin"></i>';
            jQuery(elem).html('').html(addition);
        }

        function anima_i(elem, remove, add) {
            jQuery(elem).removeClass(remove).addClass(add);
        }

        return {
            toggle: toggle,
            anima_i: anima_i
        };
    }]);

    app.factory('menu', ['jQuery', function (jQuery) {
        var ctr = jQuery('#main-content'),
            lfBtn = jQuery('#left-menu-toggle'),
            lfSwipe = jQuery('.left-swipe-area'),
            rtBtn = jQuery('#right-menu-toggle'),
            rtSwipe = jQuery('.right-swipe-area'),
            toggleLeft = function () {
                jQuery('.lfnav').toggleClass('nav-left nav-open');
                lfBtn.toggleClass('mc-left-push');
                lfSwipe.toggleClass('mc-left-push');
                rtBtn.toggleClass('mc-left-push');
                rtSwipe.toggleClass('mc-left-push');
                ctr.toggleClass('mc-left-push');
            },
            toggleRight = function () {
                jQuery('.rtnav').toggleClass('nav-right nav-open');
                rtBtn.toggleClass('mc-right-push');
                rtSwipe.toggleClass('mc-right-push');
                lfBtn.toggleClass('mc-right-push');
                lfSwipe.toggleClass('mc-right-push');
                ctr.toggleClass('mc-right-push');
            };
        return {
            toggleLeft: toggleLeft,
            toggleRight: toggleRight
        };
    }]);
    app.factory('notifier', ['toastr',
        function (toastr) {

            (function setToasterOptions() {
                toastr.options.closeButton = true;
            }());

            function notify(message, type) {
                if (type === 'success') {
                    toastr.success(message);
                } else if (type === 'warning') {
                    toastr.warning(message);
                } else if (type === 'error') {
                    toastr.error(message);
                } else {
                    toastr.info(message);
                }
            }

            return {
                notify: notify
            };
        }]);

    app.factory('common_service', ['Math', 'jQuery', 'Modernizr', 'navigator', function (Math, jQuery, Modernizr, navigator) {

        var random_number = function (limit) {
                return Math.floor((Math.random() * limit));
            },
            is_touch_device = function () {
                return Modernizr.touch === true;
            },
            is_mobile_device = function () {
                return jQuery.browser.mobile === true;
            },
            is_device = {
                Android: function () {
                    return navigator.userAgent.match(/Android/i);
                },
                BlackBerry: function () {
                    return navigator.userAgent.match(/BlackBerry/i);
                },
                iOS: function () {
                    return navigator.userAgent.match(/iPhone|iPad|iPod/i);
                },
                iPhone: function () {
                    return navigator.userAgent.match(/iPhone/i);
                },
                iPad: function () {
                    return navigator.userAgent.match(/iPad/i);
                },
                Opera: function () {
                    return navigator.userAgent.match(/Opera Mini/i);
                },
                Windows: function () {
                    return navigator.userAgent.match(/IEMobile/i);
                },
                any: function () {
                    return (is_device.Android() || is_device.BlackBerry() || is_device.iOS() || is_device.Opera() || is_device.Windows());
                }
            },
            is_browser = {
                safari: function () {
                    return navigator.userAgent.match(/(iPad|iPhone|iPod touch);.*CPU.*OS 7_\d/i);
                },
                chrome: function () {
                    return navigator.userAgent.indexOf('Chrome') > -1;

                },
                firefox: function () {
                    return navigator.userAgent.indexOf('Firefox') > -1;
                },
                which_browser: function () {
                    is_browser.safari();
                    is_browser.chrome();
                    is_browser.firefox();

                }
            };

        function is_transform3d() {
            return Modernizr.csstransforms3d;
        }

        function extend(base, addons) {
            return jQuery.extend({}, base, addons);
        }

        function numbers(startRange, endRange) {
            var nums = [], i, option;
            for (i = startRange; i <= endRange; i++) {
                option = {};
                if (i < 10) {
                    option.name = '0' + i.toString();
                    option.value = '0' + i.toString();
                } else {
                    option.name = i;
                    option.value = i;
                }
                nums.push(option);
            }
            return nums;
        }

        function random_logo() {

            var logo = 'assets/img/site/default/', logos;

            if (is_mobile_device()) {
                logo = logo + 'port/';

            } else if (!is_mobile_device()) {
                logo = logo + 'desk/';
            }

            logos = ['black_red', 'black_blue', 'black_green', 'black_orange', 'gold_orange',
                'orange_black', 'white_red', 'white', 'red_white', 'black_pant'];

            return logo + logos[random_number(logos.length - 1)] + '.gif';
        }

        function random_colors() {

            var colors = ['rgb(160,236,111)', 'rgb(255,130,130)',
                'rgb(90,198,255)', 'rgb(28,154,115)', 'rgb(245,230,102)',
                'rgb(253,193,98)', 'rgb(246,141,187)', 'rgb(10,194,210)',
                'rgb(123,183,250)', 'rgb(245,222,179)', 'rgb(183,183,183)', 'rgb(134, 185, 51)'];

            return colors[random_number(colors.length - 1)];
        }

        function is_smartPhone() {
            return is_mobile_device() && is_touch_device();
        }

        return {
            random_colors: random_colors,
            random_logo: random_logo,
            is_transform3d: is_transform3d,
            extend: extend,
            is_touch_device: is_touch_device,
            is_mobile_device: is_mobile_device,
            random_number: random_number,
            is_device: is_device,
            is_browser: is_browser,
            numbers: numbers,
            is_smartPhone: is_smartPhone
        };
    }]);

    app.factory('constant_service', [
        function () {
            function numbers(startRange, endRange) {
                var nums = [], i, option;
                for (i = startRange; i <= endRange; i++) {
                    option = {};
                    if (i < 10) {
                        option.name = '0' + i.toString();
                        option.value = '0' + i.toString();
                    } else {
                        option.name = i;
                        option.value = i;
                    }
                    nums.push(option);
                }
                return nums;
            }

            function app_occ() {
                return [
                    {name: 'Other', value: 'Other'},
                    {name: 'Student', value: 'Student'},
                    {name: 'Unemployed', value: 'Unemployed'},
                    {name: 'Accounting & Auditing', value: 'Accounting & Auditing'},
                    {name: 'Administrative & Support', value: 'Administrative & Support'},
                    {name: 'Advertising, Marketing', value: 'Advertising, Marketing'},
                    {name: 'Arts, Entertainment & Media', value: 'Arts, Entertainment & Media'},
                    {name: 'Banking', value: 'Banking'},
                    {name: 'Consulting Services', value: 'Consulting Services'},
                    {name: 'Design', value: 'Design'},
                    {name: 'Engineering', value: 'Engineering'},
                    {name: 'Finance & Economics', value: 'Finance & Economics'},
                    {name: 'Human Resources', value: 'Human Resources'},
                    {name: 'Industry', value: 'Industry'},
                    {name: 'Information Technology', value: 'Information Technology'},
                    {name: 'Law Enforcement', value: 'Law Enforcement'},
                    {name: 'Manufacturing', value: 'Manufacturing'},
                    {name: 'Restaurant & Food Service', value: 'Restaurant & Food Service'},
                    {name: 'Personal Care', value: 'Personal Care'},
                    {name: 'Public Relations Jobs', value: 'Public Relations Jobs'},
                    {name: 'Sales', value: 'Sales'},
                    {name: 'Science & Research', value: 'Science & Research'},
                    {name: 'Security', value: 'Security'},
                    {name: 'Technician', value: 'Technician'},
                    {name: 'Warehousing & Distribution', value: 'Warehousing & Distribution'}
                ];
            }

            return {
                app_occ: app_occ,
                numbers: numbers
            };
        }]);
    app.factory('timer_service', [function () {
        function time(milliseconds) {
            var oneHour = 3600000,
                oneMinute = 60000,
                oneSecond = 1000,
                seconds = 0,
                minutes = 0,
                hours = 0,
                result;

            if (milliseconds >= oneHour) {
                hours = Math.floor(milliseconds / oneHour);
            }

            milliseconds = hours > 0 ? (milliseconds - hours * oneHour) : milliseconds;

            if (milliseconds >= oneMinute) {
                minutes = Math.floor(milliseconds / oneMinute);
            }

            milliseconds = minutes > 0 ? (milliseconds - minutes * oneMinute) : milliseconds;

            if (milliseconds >= oneSecond) {
                seconds = Math.floor(milliseconds / oneSecond);
            }

            milliseconds = seconds > 0 ? (milliseconds - seconds * oneSecond) : milliseconds;

            if (hours > 0) {
                result = (hours > 9 ? hours : "0" + hours) + ":";
            } else {
                result = "00:";
            }

            if (minutes > 0) {
                result += (minutes > 9 ? minutes : "0" + minutes) + ":";
            } else {
                result += "00:";
            }

            if (seconds > 0) {
                result += (seconds > 9 ? seconds : "0" + seconds);
            } else {
                result += "00";
            }
            return result;
        }

        return {
            time: time
        };
    }]);
    app.factory('page_manager', ['$anchorScroll', '$routeParams', '$location', '$window',
        function ($anchorScroll, $routeParams, $location, $window) {

            function new_page(page) {
                var url = $location.absUrl() + '/' + page;
                $window.open(url);
            }

            function anchor() {
                $anchorScroll();
            }

            function page_id() {
                return $routeParams.id;
            }

            function navigate(url) {
                $location.path(url);
            }

            function share_link(id) {
                if (page_id() !== undefined) {
                    return $location.absUrl();
                } else {
                    return $location.absUrl() + '/' + (id !== undefined ? id : '');
                }
            }

            return {
                anchor: anchor,
                page_id: page_id,
                navigate: navigate,
                share_link: share_link,
                new_page: new_page
            };
        }]);
    app.factory('modal_manager', ['jQuery', 'menu', '$timeout', function (jQuery, menu, $timeout) {
        function menu_op(scope) {
            if (jQuery('.smnrtnav, .smnlfnav').hasClass('nav-open')) {
                if (jQuery('.smnrtnav').hasClass('nav-open')) {
                    scope.right_btn.toggle_right_nav();
                    menu.toggleRight();
                }
                if (jQuery('.smnlfnav').hasClass('nav-open')) {
                    scope.left_btn.toggle_left_nav();
                    menu.toggleLeft();
                }
                return true;
            }
            return false;
        }

        function op(elm, scope) {
            var t = 0;
            if (menu_op(scope)) {
                t = 1000;
            }
            $timeout(function () {
                jQuery(elm).modal('show');
            }, t);
        }

        function op_src(scope) {
            op('#search-modal', scope);
        }

        function op_art(scope) {
            op('#xart-modal', scope);
        }

        function op_sta(scope) {
            op('#status-modal', scope);
        }

        function cl_stat() {
            jQuery('#status-modal').modal('hide');
            $timeout(function () {
                jQuery('#auth-modal').modal('show');
                $timeout(function () {
                    jQuery('#imail').focus();
                }, 500);
            }, 200);
        }

        function op_au(scope) {
            op('#auth-modal', scope);
            $timeout(function () {
                jQuery('#imail').focus();
            }, 500);
        }

        function open_profile() {

        }

        return {
            op_art: op_art,
            menu_op: menu_op,
            op_sta: op_sta,
            cl_stat: cl_stat,
            op_au: op_au,
            op_src: op_src
        };
    }]);
    app.factory('news_service', ['request_manager', function (request_manager) {

        function get_news(size) {
            var http = {method: 'GET', url: 'search?size=' + (size || ''), data: undefined, info: 'get_news'};
            return request_manager.async_request(http);
        }

        function get_paged_news(page) {
            var http = {method: 'GET', url: 'articles' + (page || ''), data: undefined, info: 'get_paged_news'};
            return request_manager.async_request(http);
        }

        function get_article(id) {
            var http = {method: 'GET', url: 'id/' + (id || ''), data: undefined, info: 'get_article'};
            return request_manager.async_request(http);
        }

        function get_reco() {
            var http = {method: 'GET', url: 'userrec', data: undefined, info: 'get_RECO'};
            return request_manager.async_request(http);
        }

        return {
            get_news: get_news,
            get_paged_news: get_paged_news,
            get_article: get_article,
            get_reco: get_reco
        };
    }]);
    app.factory('news_manager', ['$q', 'news_service', 'store_manager', 'common_service',
        function ($q, news_service, store_manager, cs) {
            function fetch_page(page) {
                var defer = $q.defer();
                news_service.get_paged_news(page).then(
                    function (response) {
                        response.next = response.paging.next.substring(response.paging.next.indexOf('?'));
                        if (response.paging.prev !== undefined) {
                            response.prev = response.paging.prev.substring(response.paging.prev.indexOf('?'));
                        }
                        defer.resolve(response);
                    },
                    function () {
                        defer.resolve(undefined);
                    }
                );
                return defer.promise;
            }

            function fetch_reco() {
                var defer = $q.defer();
                news_service.get_reco().then(
                    function (response) {
                        defer.resolve(response);
                    },
                    function () {
                        defer.resolve(undefined);
                    }
                );
                return defer.promise;
            }

            function clear_repo() {
                store_manager.remove_from_store('r_nx');
            }

            function save(key, news) {
                store_manager.add_to_store(key, news);
            }

            function get(key) {
                return store_manager.get_from_store(key);
            }

            function count(key) {
                var articles = store_manager.get_from_store(key);
                return articles === undefined ? 0 : articles.length;
            }

            function count_news() {
                return count('r_nx');
            }

            function save_repo(news) {
                save('r_nx', news);
            }

            function get_repo() {
                return get('r_nx');
            }

            function empty_db() {
                return get_repo() === undefined;
            }

            function save_read(news) {
                save('r_ax', news);
            }

            function get_read() {
                return get('r_ax');
            }

            function clear_read() {
                store_manager.remove_from_store('r_ax');
            }

            function save_hd(news) {
                save('h_nx', news);
            }

            function get_hd() {
                return get('h_nx');
            }

            function set_time(time) {
                save('rx_t', time);
            }

            function get_time() {
                return get('rx_t');
            }

            function passed_time() {
                var ot = get_time(), nt = new Date().getTime();
                if (ot !== undefined) {
                    ot = new Date(ot);
                    ot = nt - ot;
                    if (ot > (3600000 * 6)) {
                        return true;
                    }
                    return false;
                }
                return false;
            }

            function save_art(xid) {
                var arts = get_read(), ob = {id: xid}, ar = [], f = false;
                if (arts === undefined) {
                    ar.push(ob);
                    save_read(ar);
                } else if (arts !== undefined) {
                    angular.forEach(arts, function (v) {
                        if (v.id === ob.id) {
                            f = true;
                        }
                    });
                    if (!f) {
                        arts.push(ob);
                        save_read(arts);
                    }
                }
            }

            function save_rate(axid, rate) {
                var arts = get_read();
                angular.forEach(arts, function (v) {
                    if (v.id === axid) {
                        v.rate = rate;
                        save_read(arts);
                        return;
                    }

                });
            }

            function get_rate(axid) {
                var arts = get_read(), r = 0;
                angular.forEach(arts, function (v) {
                    if (v.id === axid) {
                        if (v.rate !== undefined) {
                            r = v.rate;
                        }
                    }
                });
                return r;
            }

            function is_read(id) {
                var arts = get_read(), f = false;
                if (arts !== undefined) {
                    angular.forEach(arts, function (v) {
                        if (v.id === id) {
                            f = true;
                        }
                    });
                }
                return f;
            }

            function get_from_repo(size) {
                var articles = get_repo(), result = [], i;
                if (articles !== undefined) {
                    for (i = (size - 50); i < size; i = (i + 1)) {
                        if (articles[i] !== undefined) {
                            result.push(articles[i]);
                        }
                    }
                    return result;
                }
                return undefined;
            }

            function get_news(size) {
                var news = [], imgs = [], defer = $q.defer(), article, geo = [], shape;
                news_service.get_news(size).then(
                    function (response) {
                        angular.forEach(response, function (val) {
                            if (val._source.entities !== undefined && val._source.entities.length > 0) {
                                shape = val._source.entities;
                                angular.forEach(shape, function (v) {
                                    if (v.entity.geoShape) {
                                        if (v.entity.geoShape.coordinates) {
                                            geo = v.entity.geoShape.coordinates;
                                        }
                                    } else {
                                        geo = [];
                                    }
                                });
                            } else {
                                geo = [];
                            }
                            delete  val._source.type;
                            delete  val._source.nodeId;
                            delete  val._source.keywords;
                            delete  val._source.noiseCategories;
                            delete  val._source.sourceUrl;
                            delete  val._source.sentimentValue;
                            delete  val._source.language;
                            delete  val._source.indexed;
                            delete  val._source.sentences;
                            delete  val._source.noiseSentences;
                            delete  val._source.originalCategories;
                            delete  val._source.tags;
                            delete  val._source.score;
                            article = { src: val._source, img: val.smartnews.image, geo: geo};
                            news.push(article);
                            if (article.src.images[0] !== undefined) {
                                imgs.push(article);
                            }
                        });
                        save_hd(imgs);
                        save_repo(news);
                        set_time(new Date());
                        defer.resolve(news);
                    },
                    function () {
                        defer.resolve(undefined);
                    }
                );

                return defer.promise;
            }

            function update() {
                var defer = $q.defer(), size = 200;
                if (cs.is_smartPhone()) {
                    size = 100;
                }
                defer.resolve(get_news(size));
                return defer.promise;
            }

            function start_fetch(force, size) {
                size = size || 400;
                var defer = $q.defer(), articles = get_repo();
                if (force === true || articles === undefined || size > articles.length) {
                    if (size >= 500) {
                        size = 500;
                    }
                    defer.resolve(get_news(size));
                } else if (articles !== undefined) {
                    defer.resolve(articles);
                }
                return defer.promise;
            }

            function fetch(size) {
                size = (size || 50);
                var defer = $q.defer(), articles = get_repo();
                if (articles === undefined) {
                    defer.resolve(start_fetch(false, size));
                } else if (size >= articles.length) {
                    start_fetch(false, (size + size)).then(function () {
                        defer.resolve(get_from_repo(size));
                    });
                } else if (size < articles.length) {
                    defer.resolve(get_from_repo(size));
                }
                return defer.promise;
            }

            function news() {
                var defer = $q.defer(), size = 400;
                if (cs.is_smartPhone()) {
                    size = 100;
                }
                if (empty_db()) {
                    defer.resolve(start_fetch(size));
                } else if (passed_time()) {
                    defer.resolve(start_fetch(true, size));
                } else {
                    defer.resolve(1);
                }
                return defer.promise;
            }

            function select_img() {
                return get_hd();
            }

            function lc_art_id(id) {
                var art = get_repo(), defer = $q.defer();
                if (art !== undefined) {
                    angular.forEach(art, function (val) {
                        if (val.src.articleId === id) {
                            defer.resolve(val);
                            return defer.promise;
                        }
                    });
                }
                defer.resolve(undefined);
                return defer.promise;
            }

            function sv_art_id(id) {
                var defer = $q.defer(), art;
                news_service.get_article(id).then(function (response) {
                    if (response.length > 0) {
                        angular.forEach(response, function (val) {
                            art = { src: val._source, img: val.smartnews.image};
                            defer.resolve(art);
                        });
                    } else {
                        defer.resolve(undefined);
                    }
                });
                return defer.promise;
            }

            return {
                start_fetch: start_fetch,
                fetch: fetch,
                update: update,
                clear_repo: clear_repo,
                select_img: select_img,
                lc_art_id: lc_art_id,
                sv_art_id: sv_art_id,
                save_art: save_art,
                is_read: is_read,
                save_rate: save_rate,
                get_rate: get_rate,
                news: news,
                empty_db: empty_db,
                passed_time: passed_time,
                count_news: count_news,
                fetch_reco: fetch_reco
            };
        }]);
    app.factory('art_utility', [ function () {
        function xbreaks(s) {
            if (s !== undefined) {
                var a = s.split('');
                angular.forEach(a, function (v, k) {
                    if (v === '*' || v === '–' || (a[k - 1] === ' ' && a[k] === '-' && a[k + 1] === ' ')) {
                        a[k] = '\n';
                    }
                });
                return a.join('').toString();
            }
            return s;
        }

        function x_trim(s, e) {
            if (s) {
                if (e >= 40) {
                    return s.length > e ? s.slice(0, e) + '....' : s;
                }
                return s.slice(0, e);
            }
            return s;
        }

        return {
            xbreaks: xbreaks,
            x_trim: x_trim
        };
    }]);
    app.factory('event_service', ['request_manager', function (request_manager) {
        function post_events(events) {
            var http = {method: 'POST', url: 'events', data: events, info: 'post_events'};
            return request_manager.async_request(http);
        }

        return {
            post_events: post_events
        };
    }]);

    app.factory('event_manager', ['$q', 'event_service', 'identity_manager', 'store_manager',
        function ($q, event_service, identity_manager, store_manager) {
            function save_rating(r) {
                store_manager.add_to_store('x_rate', r);
            }

            function get_rating_store() {
                return store_manager.get_from_store('x_rate');
            }

            function clean_rating_store() {
                store_manager.remove_from_store('x_rate');
            }

            function post_events(user, events) {
                var defer = $q.defer(), identity;
                if (user !== undefined && events.length > 0) {
                    identity = identity_manager.approval_of_identity(user);
                    if (identity !== undefined) {
                        identity.events = events;
                        event_service.post_events(identity).
                            then(
                            function (response) {
                                defer.resolve(response);
                            },
                            function (response) {
                                defer.reject(response);
                            }
                        );
                    }
                }
                return defer.promise;
            }

            function register_ratings(user, events) {
                var defer = $q.defer();
                post_events(user, events).
                    then(function (response) {
                        if (response.error === 0 && response.nevents === events.length) {
                            defer.resolve(true);
                        } else {
                            defer.resolve(false);
                        }
                    }, function () {
                        defer.resolve(false);
                    });
                return defer.promise;
            }

            function add_all_ratings(user) {
                var ratings = get_rating_store();
                register_ratings(user, ratings).then(function (result) {
                    if (result) {
                        clean_rating_store();
                    }
                    return result;
                });
            }

            function add_rating_store(user, rating) {
                var ratings = get_rating_store(), s = true;
                if (ratings === undefined) {
                    ratings = [];
                    ratings.push(rating);
                    save_rating(ratings);
                } else {
                    angular.forEach(ratings, function (v) {
                        if (v.article_id === rating.article_id) {
                            if (v.rating !== rating.rating) {
                                v.rating = rating.rating;
                                save_rating(ratings);
                            }
                            s = false;
                        }
                    });
                    if (s) {
                        ratings.push(rating);
                        save_rating(ratings);
                    }
                    if (ratings.length >= 20) {
                        add_all_ratings(user);
                    }
                }
            }

            function add_rating(user, rating) {
                var defer = $q.defer(), identity;
                if (user !== undefined && rating !== undefined) {
                    identity = identity_manager.approval_of_identity(user);
                    if (identity !== undefined) {
                        add_rating_store(user, rating);
                        defer.resolve(true);
                    }
                } else {
                    defer.resolve(false);
                }
                return defer.promise;
            }

            return {
                add_rating: add_rating
            };
        }]);
    app.factory('user_service', ['request_manager', function (request_manager) {

        function authenticate(user) {
            var http = {method: 'POST', url: 'auth', data: user, info: 'authenticate_user'};
            return request_manager.async_request(http);
        }

        function register(user) {
            var http = {method: 'POST', url: 'register', data: user, info: 'register_user'};
            return request_manager.async_request(http);
        }

        function logout(user) {
            var http = {method: 'GET', url: 'logout', data: user, info: 'logout_user'};
            return request_manager.async_request(http);
        }

        function get_profile(user) {
            var http = {method: 'GET', url: 'profile', data: user, info: 'GET: PROFILE'};
            return request_manager.async_request(http);
        }

        function set_profile(profile) {
            var http = {method: 'POST', url: 'profile', data: profile, info: 'SET: PROFILE'};
            return request_manager.async_request(http);
        }

        function get_prefs(user) {
            var http = {method: 'GET', url: 'prefs', data: user, info: 'GET: PREFS'};
            return request_manager.async_request(http);
        }

        function set_prefs(profile) {
            var http = {method: 'POST', url: 'prefs', data: profile, info: 'SET: PREFS'};
            return request_manager.async_request(http);
        }


        function get_location() {
            var http = {method: 'JSONP', xurl: 'http://ipinfo.io?callback=JSON_CALLBACK', data: undefined, info: 'get_location'};
            return request_manager.async_request(http);
        }

        return {
            authenticate: authenticate,
            register: register,
            logout: logout,
            get_profile: get_profile,
            set_profile: set_profile,
            get_prefs: get_prefs,
            set_prefs: set_prefs,
            get_location: get_location
        };
    }]);
    app.factory('user_manager', ['$q', 'user_service', 'identity_manager', 'common_service', 'md5',
        function ($q, user_service, identity_manager, common_service, md5) {

            function handle_auth_res(response, user) {
                if (response.error === 0) {
                    user.addons = {image_url: 'https://s.gravatar.com/avatar/' + md5(user.email) + '?s=100'};
                    var authenticated = common_service.extend(user, response);
                    identity_manager.set_user_identity(authenticated);
                    return authenticated;
                }
                return undefined;
            }

            function handle_response(response) {
                if (response.error === 0) {
                    return 1;
                }
                return -1;
            }

            function identify_user() {
                return identity_manager.get_user_identity();
            }

            function authenticate_user(user) {
                var defer = $q.defer();
                if (user !== undefined) {
                    if (user.email !== undefined && user.password !== undefined) {
                        user_service.authenticate(user).
                            then(
                            function (response) {
                                defer.resolve(handle_auth_res(response, user));
                            },
                            function (response) {
                                defer.reject(response);
                            }
                        );
                    }
                }
                return defer.promise;
            }

            function register_user(user) {
                var defer = $q.defer();
                if (user !== undefined) {
                    if (user.email !== undefined && user.password !== undefined) {
                        user.registration_date = new Date();
                        user_service.register(user).
                            then(
                            function (response) {
                                defer.resolve(handle_auth_res(response, user));
                            },
                            function (response) {
                                defer.reject(response);
                            }
                        );
                    }
                }
                return defer.promise;
            }

            function logout_user() {
                var defer = $q.defer(),
                    identity = identity_manager.get_user_identity();
                if (identity !== undefined) {
                    user_service.logout(identity).
                        then(
                        function (response) {
                            if (response.error === 0) {
                                identity_manager.remove_user_identity();
                                defer.resolve(true);
                            }
                        },
                        function (response) {
                            defer.reject(response);
                        }
                    );
                }
                return defer.promise;
            }

            function get_user_profile(user) {
                var defer = $q.defer(), identity;
                if (user !== undefined) {
                    identity = identity_manager.approval_of_identity(user);
                    if (identity !== undefined) {
                        user_service.get_profile(identity).
                            then(
                            function (response) {
                                defer.resolve(response);
                            },
                            function (response) {
                                defer.reject(response);
                            }
                        );
                    }
                }
                return defer.promise;
            }

            function set_user_profile(user, profile) {

                var defer = $q.defer(), identity;
                if (user !== undefined && profile !== undefined && Object.keys(profile).length > 0) {
                    identity = identity_manager.approval_of_identity(user);
                    if (identity !== undefined) {
                        identity.profile = profile;
                        user_service.set_profile(identity).
                            then(
                            function (response) {
                                defer.resolve(handle_response(response));
                            },
                            function (response) {
                                defer.reject(response);
                            }
                        );
                    }
                }
                return defer.promise;
            }

            function get_user_prefs(user) {
                var defer = $q.defer(), identity;
                if (user !== undefined) {
                    identity = identity_manager.approval_of_identity(user);
                    if (identity !== undefined) {
                        user_service.get_prefs(identity).
                            then(
                            function (response) {
                                defer.resolve(response);
                            },
                            function (response) {
                                defer.reject(response);
                            }
                        );
                    }
                }
                return defer.promise;
            }

            function set_user_prefs(user, prefs) {
                var defer = $q.defer(), identity;
                if (user !== undefined && prefs !== undefined && Object.keys(prefs).length > 0) {
                    identity = identity_manager.approval_of_identity(user);
                    if (identity !== undefined) {
                        identity.prefs = prefs;
                        user_service.set_prefs(identity).
                            then(
                            function (response) {
                                defer.resolve(handle_response(response));
                            },
                            function (response) {
                                defer.reject(response);
                            }
                        );
                    }
                }
                return defer.promise;
            }

            function current_loc() {
                var defer = $q.defer();
                user_service.get_location().then(
                    function (r) {
                        var c = r.loc.split(','),
                            l = { city: r.city, region: r.region,
                                country: r.country, latitude: c[0], longitude: c[1]};
                        defer.resolve(l);
                    },
                    function () {
                        defer.resolve(undefined);
                    }
                );
                return defer.promise;
            }

            return {
                identify_user: identify_user,
                authenticate_user: authenticate_user,
                register_user: register_user,
                logout_user: logout_user,
                get_user_profile: get_user_profile,
                set_user_profile: set_user_profile,
                get_user_prefs: get_user_prefs,
                set_user_prefs: set_user_prefs,
                current_loc: current_loc
            };
        }]);
    app.factory('identity_manager', ['$cookieStore', function ($cookieStore) {
        function set_user_identity(identity) {
            delete identity.password;
            delete identity.email;
            if (identity !== undefined && identity !== null) {
                $cookieStore.put('identity', identity);
            }
        }

        function get_user_identity() {
            var identity = $cookieStore.get('identity');
            if (identity !== undefined) {
                return identity;
            }
            return undefined;
        }

        function site_requester_identify() {
            return get_user_identity();
        }

        function remove_user_identity() {
            $cookieStore.remove('identity');
        }

        function approval_of_identity(user) {
            var identity = site_requester_identify();
            if (identity !== undefined) {
                if ((user.uid === identity.uid)/* &&
                 (user.email === identity.email) /* &&
                 (user.password) === (identity.password)*/) {
                    return identity;
                }
            }
            return undefined;
        }

        return {
            site_requester_identify: site_requester_identify,
            set_user_identity: set_user_identity,
            get_user_identity: get_user_identity,
            remove_user_identity: remove_user_identity,
            approval_of_identity: approval_of_identity
        };
    }]);
    var google_map = function ($scope, $timeout, $rootScope, prefs) {
        var mapOptions = { disableDefaultUI: true, panControl: false,
            zoomControl: false, scaleControl: false, mapTypeControl: false, scrollwheel: false }, loc;
        $scope.map_r = true;
        $scope.map_c = {location: false, load: false};
        $scope.map_c.s_map = {center: {latitude: 63.415424, longitude: 10.408408}, zoom: 15, options: mapOptions};
        $scope.map_c.s_marker = {icon: 'assets/img/site/default/ntnu_logo.png', coords:
        {latitude: 63.415424, longitude: 10.408408}};
        function map_ready(a) {
            $rootScope.$broadcast('map_ready', function () {
                return a;
            });
        }
        function user_loc(a) {
            loc = prefs.get_geo();
            if (loc !== undefined) {
                $scope.map_c.a_map = {center:
                {latitude: loc.latitude || 63.415424, longitude: loc.longitude || 10.408408}, zoom: 10, options: mapOptions};
                $scope.map_c.a_marker = {icon: 'assets/img/site/default/home.png', coords:
                {latitude: loc.latitude || 63.415424, longitude: loc.longitude || 10.408408}};
                $scope.map_c.location = true;
                map_ready(a);
            } else if (loc === undefined) {
                $scope.map_c.location = false;
                map_ready(a);
            }
        }

        $timeout(function () {
            user_loc(0);
        }, 180);
        $scope.$on('delete_geo', function () {
            $scope.map_c.location = false;
            $scope.map_c.load = false;
        });
        $scope.$on('location_on', function () {
            $timeout(function () {
                user_loc(1);
            }, 180);
        });
        $scope.$on('get_location', function () {
            $scope.map_c.load = true;
        });
    };
    google_map.$inject = ['$scope', '$timeout', '$rootScope', 'preferences'];
    app.controller('google_map', google_map);

    var shell = function ($scope, $anchorScroll) {
        $anchorScroll();
        $scope.shell_ctrl = {};
    };
    shell.$inject = ['$scope', '$anchorScroll'];
    app.controller('shell', shell);

    var art_page = function ($scope, $window) {
        $window.scrollTo(0,0);
        $scope.goBack = function () {
            history.go(-1);
        };
    };
    art_page.$inject = ['$scope', '$window'];
    app.controller('art_page', art_page);

    var news = function ($scope, $timeout, $q, $rootScope, news_manager,
                         art_utility, page_manager, modal_manager, hotWire, em, notifier) {
        $scope.utils = art_utility;
        $scope.n_ctrl = {division: undefined, art: undefined, modal: false, updating: false};
        $scope.flag = false;
        page_manager.anchor();
        function read_mod() {
            $rootScope.$broadcast('reads', function () {
                return 1;
            });
        }

        function change_view(view, skip) {
            $rootScope.$broadcast('ch_view', function () {
                return 1;
            });
            if (skip) {
                $timeout(function () {
                    $scope.n_ctrl.division = view;
                }, 1500);
            } else if (view !== 'article') {
                $scope.n_ctrl.division = undefined;
                $timeout(function () {
                    $scope.n_ctrl.division = view;
                }, 1500);

            } else if (view === 'article') {
                $scope.n_ctrl.division = view;
            }
            $rootScope.$broadcast('ch_cp', function () {
                return 1;
            });
        }

        function nav_activate() {
            var defer = $q.defer();
            $scope.$on('right_nav', function () {
                defer.resolve(1);
            });
            return defer.promise;
        }

        function default_view(skip) {
            if (page_manager.page_id() === undefined) {
                modal_manager.menu_op($scope);
                if ($scope.right_nav === undefined) {
                    nav_activate().then(function () {
                        change_view($scope.right_nav.pref.art_view, skip);
                    });
                } else if ($scope.right_nav !== undefined) {
                    change_view($scope.right_nav.pref.art_view, skip);
                }
            }
        }

        function proceed() {
            var defer = $q.defer();
            $scope.$on('proceed', function () {
                defer.resolve(1);
            });
            return defer.promise;
        }

        function db_ready() {
            var defer = $q.defer();
            $scope.$on('ready_db', function () {
                defer.resolve(1);
            });
            return defer.promise;
        }

        function status() {
            var defer = $q.defer();
            $scope.$on('status', function () {
                defer.resolve(1);
            });
            return defer.promise;
        }

        function article(art) {
            read_mod();
            change_view('article');
            news_manager.save_art(art.src.articleId);
        }

        function set_article(art) {
            $scope.n_ctrl.art = art;
            hotWire.art = art;
            if ($scope.auth === undefined) {
                proceed().then(function () {
                    if ($scope.auth.identity === undefined) {
                        status().then(function () {
                            $scope.modal_status.open();
                            proceed().then(function () {
                                article(art);
                            });
                        });
                    } else if ($scope.auth.identity !== undefined) {
                        article(art);
                    }
                });
            } else {
                article(art);
            }

        }

        function get_more_articles() {
            var defer = $q.defer();
            news_manager.fetch($scope.articles.length + 50).then(function (news) {
                if (news && news.length > 0) {
                    defer.resolve(news);
                } else {
                    defer.resolve(undefined);
                }
            });
            return defer.promise;
        }

        function get_news(skip) {
            news_manager.fetch(50).then(function (news) {
                if (news && news.length > 0) {
                    $scope.articles = news;
                    $scope.hd = news_manager.select_img();
                    hotWire.articles = $scope.articles;
                    hotWire.hd = $scope.hd;
                    default_view(skip);
                } else {
                    notifier.notify('Unavailable service...', 'error');
                    $timeout(function () {
                        page_manager.navigate('home/');
                    }, 2000);
                }
            });
        }

        if (hotWire.articles !== undefined && hotWire.hd !== undefined) {
            $scope.articles = hotWire.articles;
            $scope.hd = hotWire.hd;
            default_view();
        } else if (hotWire.flag === true) {
            db_ready().then(function () {
                get_news();
            });
        } else if (($scope.articles === undefined || $scope.hd === undefined)) {
            if (news_manager.empty_db() || news_manager.passed_time()) {
                notifier.notify('Updating news...');
                news_manager.start_fetch(news_manager.passed_time()).then(function (response) {
                    if (response && response.length > 0) {
                        get_news();
                    } else {
                        notifier.notify('Unavailable service...', 'error');
                        $timeout(function () {
                            page_manager.navigate('home/');
                        }, 2000);
                    }
                });
            } else {
                get_news();
            }
        }

        if (page_manager.page_id() !== undefined) {
            if (hotWire.art === undefined) {
                news_manager.lc_art_id(page_manager.page_id()).then(function (lart) {
                    if (lart === undefined) {
                        news_manager.sv_art_id(page_manager.page_id()).then(function (sart) {
                            if (sart === undefined) {
                                change_view('error');
                            } else {
                                set_article(sart);
                            }
                        });
                    } else {
                        set_article(lart);
                    }
                });
            } else {
                set_article(hotWire.art);
            }
        }
        hotWire.flag = false;
        $scope.$watch('right_nav.pref.art_view', function (nval, oval) {
            if (nval !== oval) {
                $rootScope.$broadcast('ch_cp', function () {
                    return 1;
                });
                modal_manager.menu_op($scope);
                change_view(nval);
            }
        });
        $scope.$watch('auth.identity', function (nval, oval) {
            if (nval !== oval && nval !== undefined) {
                hotWire.event.user_id = nval.uid;
            }
        });
        $scope.$watch('n_ctrl.art', function (nval, oval) {
            if (nval) {
                hotWire.event.article_id = nval.src.articleId;
                read_mod();
            }
        });
        function compete_update(u) {
            $rootScope.$broadcast('up_news_e', function () {
                return u;
            });
        }

        $scope.$on('up_news_s', function (ev, sn) {
            $rootScope.$broadcast('ch_view', function () {
                return 1;
            });
            var action = sn();
            notifier.notify('Updating news...', 'warning');
            $scope.n_ctrl.division = undefined;
            news_manager.update().then(function (res) {
                if (res && res.length > 0) {
                    if (action === 1) {
                        get_news();
                    } else if (action === 0) {
                        get_news(1);
                    }
                    notifier.notify('News are updated...');
                    compete_update(1);
                } else {
                    notifier.notify('Unavailable service...', 'error');
                    compete_update(0);
                    $timeout(function () {
                        page_manager.navigate('home/');
                    }, 2000);
                }
            });
        });
        $scope.$on('end_page', function () {
            $scope.n_ctrl.updating = true;
            get_more_articles().then(function (news) {
                $timeout(function () {
                    $scope.n_ctrl.updating = false;
                    if (news !== undefined) {
                        $scope.articles = $scope.articles.concat(news);
                        hotWire.articles = $scope.articles;
                    }

                }, 3000);
            });
        });

        $scope.$on('finally', function () {
            $scope.n_ctrl.modal = false;
            em.add_rating($scope.auth.identity, hotWire.event).then(function (r) {
                if (r) {
                    $scope.n_ctrl.art = undefined;
                    hotWire.event.article_id = undefined;
                    hotWire.event.timestamp = undefined;
                    hotWire.event.time_spent = undefined;

                }

            });
        });
        function mode(art, force) {

            hotWire.art = art;
            if ($scope.right_nav.pref.opening === 'neww' || force === true) {
                page_manager.new_page(art.src.articleId);
                $scope.n_ctrl.modal = false;
            } else if ($scope.right_nav.pref.opening === 'page') {
                $scope.n_ctrl.modal = false;
                page_manager.navigate('news/' + art.src.articleId);
            } else if ($scope.right_nav.pref.opening === 'modal') {
                $scope.n_ctrl.art = art;
                $scope.n_ctrl.modal = true;
                modal_manager.op_art($scope);
                $scope.flag = true;
                news_manager.save_art(art.src.articleId);
            }
        }

        $scope.xopen = function (art, f) {
            if ($scope.auth.identity === undefined) {
                modal_manager.op_sta($scope);
                proceed().then(function () {
                    mode(art, f);
                });
            } else if ($scope.auth.identity !== undefined) {
                mode(art, f);
            }
        };

    };
    news.$inject = ['$scope', '$timeout', '$q', '$rootScope',
        'news_manager', 'art_utility', 'page_manager', 'modal_manager', 'hotWire', 'event_manager', 'notifier'];
    app.controller('news', news);

    app.directive('smnShell',[
        function () {
            return {
                restrict: 'A',
                templateUrl: 'assets/public/directives/main/shell.html',
                replace: true
            };
        }]);
    app.directive('smnGreeting', ['$location', '$timeout', 'notifier', 'common_service',
        function ($location, $timeout, notifier, common_service) {
            return {
                restrict: 'A',
                templateUrl: 'assets/public/directives/main/greeting.html',
                replace: true,
                link: function (scope) {

                    scope.greeting = {main_logo: undefined};
                    scope.greeting.main_logo = common_service.random_logo();
                    var notify = [
                        {i: 'Preparing the application...', t: 'info'}
                    ];
                    if (scope.right_nav !== undefined && scope.right_nav.pref !== undefined) {
                        if (scope.right_nav.pref.location === true) {
                            notify.push({i: 'Location: On', t: 'info'});
                        } else {
                            notify.push({i: 'Location: Off', t: 'warning'});
                        }
                        if (scope.right_nav.pref.hints === true) {
                            notify.push({i: 'Hints: On', t: 'info'});
                        } else {
                            notify.push({i: 'Hints: Off', t: 'warning'});
                        }

                    }
                    var i = 0, progress_bar;
                    angular.forEach(notify, function (v) {
                        $timeout(function () {
                            notifier.notify(v.i, v.t);
                        }, i === 0 ? 500 : (i * 1500));
                        i++;
                    });
                    progress_bar = angular.element('.progress-bar');

                    function finish() {
                        if ($location.path() === '/') {
                            $location.url('home');
                        }
                    }

                    function changeBg(color) {
                        angular.element('html, body').css('background-color', color);
                    }

                    function progress() {
                        var cb = common_service.random_number(500), counter = 0,
                            countDown = function () {
                                counter = counter + 1;
                                if (counter === 11) {
                                    $timeout(function () {
                                        finish();
                                    }, 500);
                                } else {
                                    progress_bar.width(counter * 10 + "%");
                                    $timeout(function () {
                                        countDown();
                                    }, cb);
                                }
                            };
                        countDown();
                    }

                    function setupBg() {

                        var background_one = common_service.random_colors(),
                            background_two = common_service.random_colors();

                        while (background_two === background_one) {
                            background_two = common_service.random_colors();
                        }
                        changeBg(background_one);
                        progress_bar.css('background-color', background_two);
                    }

                    (function () {
                        setupBg();
                        $timeout(function () {
                            progress_bar.width(common_service.random_number(10) + "%");
                            var cb = common_service.random_number(500);
                            $timeout(function () {
                                progress();
                            }, cb);
                        }, 1000);

                    }());
                }
            };
        }]);
    app.directive('smnSlider', ['common_service', function (common_service) {
        return {
            restrict: 'A',
            templateUrl: 'assets/public/directives/main/slider.html',
            replace: true,
            link: function (scope) {
                scope.slider = {img: []};
                var path = 'assets/img/site/slider/', i = 1;
                if (common_service.is_mobile_device()) {
                    path = path + 'port/';
                } else if (!common_service.is_mobile_device()) {
                    path = path + 'desk/';
                }
                for (i; i < 8; i = (i + 1)) {
                    scope.slider.img.push(path + 'smn' + i + '.jpg');
                }
            }
        };
    }]);
    app.directive('smnSlide', ['$timeout', function ($timeout) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                $timeout(function () {
                    elem.superslides(
                        {
                            play: 7000,
                            animation: 'fade',
                            animation_speed: 'slow',
                            animation_easing: 'linear',
                            pagination: false,
                            hashchange: false
                        }
                    );
                }, 10);
            }
        };

    }]);

    app.directive('smnViewHandlerDefault', ['$timeout', 'jQuery', function ($timeout, jQuery) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                scope.$on('$routeChangeStart', function (next, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/home') {
                            $timeout(function () {
                                elem.fadeIn(2000);
                            }, 2000);
                        } else if (current.$$route.originalPath === '/news') {
                            $timeout(function () {
                                elem.fadeIn(2000);
                            }, 2000);
                        } else if (current.$$route.originalPath === '/news/:id') {

                        } else if (current.$$route.originalPath === '/') {
                            elem.hide();
                        }
                    }
                });
                scope.$on('$routeChangeSuccess', function (event, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/home') {
                            $timeout(function () {
                                elem.fadeIn(2000);
                            }, 2000);
                        } else if (current.$$route.originalPath === '/news') {
                            $timeout(function () {
                                elem.fadeIn(2000);
                            }, 2000);
                        } else if (current.$$route.originalPath === '/') {
                            elem.hide();
                        }
                    }
                });
            }
        };
    }]);

    app.directive('smnViewHandlerNews', ['$timeout', function ($timeout) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                scope.$on('$routeChangeStart', function (next, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/home') {
                            elem.hide();
                        } else if (current.$$route.originalPath === '/news') {
                            elem.hide();
                        } else if (current.$$route.originalPath === '/') {
                            elem.hide();
                        }
                    }
                });
                scope.$on('$routeChangeSuccess', function (event, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/home') {
                            elem.hide();
                        } else if (current.$$route.originalPath === '/news') {
                            $timeout(function () {
                                elem.fadeIn(2000);
                            }, 2000);
                        } else if (current.$$route.originalPath === '/') {
                            elem.hide();
                        }
                    }
                });
            }
        };
    }]);

    app.directive('smnNavViewHandlerHome', [function () {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                scope.$on('$routeChangeStart', function (event, next, cureent) {
                });
                scope.$on('$routeChangeSuccess', function (event, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/home') {
                            elem.show();
                        } else if (current.$$route.originalPath === '/news') {
                            elem.hide();
                        } else if (current.$$route.originalPath === '/news/:id') {
                            elem.show();
                        }
                    }
                });
            }
        };
    }]);
    app.directive('smnNavViewHandlerArticle', [function () {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                scope.$on('$routeChangeStart', function (event, next, cureent) {
                });
                scope.$on('$routeChangeSuccess', function (event, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/news/:id') {
                            elem.hide();
                        } else if (current.$$route.originalPath === '/news') {
                            elem.show();
                        }
                    }
                });
            }
        };
    }]);
    app.directive('smnNavViewHandlerNews', [function () {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                scope.$on('$routeChangeStart', function (event, next, cureent) {
                });
                scope.$on('$routeChangeSuccess', function (event, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/home') {
                            elem.hide();
                        } else if (current.$$route.originalPath === '/news') {
                            elem.show();
                        }
                    }
                });
            }
        };
    }]);
    app.directive('smnPortableOnly', ['common_service', function (cv) {
        return {
            restrict: 'A',
            replace: true,
            link: function (s, elem) {
                if (!cv.is_mobile_device() || !cv.is_touch_device()) {
                    elem.remove();
                }
            }
        };
    }]);
    app.directive('smnTooltip', [ function () {
        return {
            restrict: 'A',
            replace: true,
            scope: {},
            link: function (s, elem) {
                elem.tooltip();
            }
        };
    }]);
    app.directive('smnDesktopOnly', ['common_service', function (cv) {
        return {
            restrict: 'A',
            replace: true,
            link: function (s, elem) {
                if (cv.is_mobile_device() || cv.is_touch_device()) {
                    elem.remove();
                }
            }
        };
    }]);
    app.directive('smnOnDown', [function () {
        return {
            restrict: 'A',
            replace: true,
            link: function (s, elem, attr) {
                elem.on('keyup', function (e, v) {
                });
            }
        };
    }]);

    app.directive('smnBtPgBroadcast', ['$document', '$window', '$routeParams', function ($document, $window, $routeParams) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope) {
                angular.element($window).bind('scroll', function () {
                    if (angular.element($window).scrollTop() + angular.element($window).height() >= angular.element($document).height()) {
                        if ($routeParams.id === undefined &&
                            scope.right_nav !== undefined &&
                            scope.right_nav.pref !== undefined &&
                            scope.right_nav.pref.art_view !== 'world' &&
                            scope.n_ctrl.division !== undefined &&
                            scope.n_ctrl.updating === false &&
                            scope.n_ctrl.modal === false) {
                            scope.$broadcast('end_page', function () {
                                return 1;
                            });

                        }
                    }
                });
            }
        };
    }]);

    app.directive('smnTheme', ['preferences', function (pref) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                function run(a) {
                    var setting = pref.xget_pref();
                    if (setting !== undefined && setting.nav_style !== undefined) {
                        if (a) {
                            elem.removeClass('theme-smn theme-retro theme-ios theme-android');
                        }
                        elem.addClass(setting.nav_style);
                    }
                }

                run();
                scope.$on('user_prefs', function () {
                    run(true);
                });
            }
        };
    }]);

    app.directive('smnSpin', ['common_service', function (cv) {
        return {
            restrict: 'A',
            replace: true,
            link: function (s, elem) {
                elem.spin({lines: 13, length: 1, width: 10, radius: 30, corners: 1, rotate: 0, direction: 1, speed: 1,
                    color: cv.random_colors(), trail: 80, shadow: true, hwaccel: false, zIndex: 2e9});
            }
        };
    }]);
    app.directive('smnRandomColor', ['common_service', function (cv) {
        return {
            restrict: 'A',
            replace: true,
            scope: {type: '='},
            link: function (s, elem) {
                var c = cv.random_colors();
                if (s.type === 1) {
                    elem.css('color', c);
                } else {
                    elem.css('background-color', c);
                }

            }
        };
    }]);
    app.directive('smnBackgroundColor', ['jQuery', function (jQuery) {
        return {
            restrict: 'A',
            replace: true,
            scope: {where: '='},
            link: function (s) {
                function add(c) {
                    jQuery('body').addClass(c);
                }

                function clean() {
                    jQuery('body').removeClass('a-bg-t m-bg-t m2-bg-t m3-bg-t m4-bg-t');
                }
                clean();
                if (s.where === 0) {
                    add('m-bg-t');
                } else if (s.where === 1) {
                    add('a-bg-t');
                } else if (s.where === 2) {
                    add('m2-bg-t');
                } else if (s.where === 3) {
                    add('m3-bg-t');
                } else if (s.where === 4) {
                    add('m4-bg-t');
                }
            }
        };
    }]);
    app.directive('smnScaleThis', [function () {
        return {
            restrict: 'A',
            replace: true,
            link: function (s, elem) {

                elem.hover(function () {
                    elem.toggleClass('smn-s-i');
                });
                elem.focus(function () {
                    elem.toggleClass('smn-s-i');
                });
            }
        };
    }]);
    app.directive('smnScaleThat', [function () {
        return {
            restrict: 'A',
            replace: true,
            link: function (s, elem) {

                elem.hover(function () {
                    elem.toggleClass('smn-s-ii');
                });
                elem.focus(function () {
                    elem.toggleClass('smn-s-ii');
                });
            }
        };
    }]);

    app.directive('smnHelp', ['preferences', 'notifier', function (pref, notifier) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                note: '=',
                multi: '=',
                ftype: '='
            },
            link: function (scope, elem) {
                var c = false, hints;
                elem.click(function (event) {
                    event.preventDefault();
                    event.stopPropagation();
                    hints = pref.xget_pref();
                    if (hints !== undefined && hints.hints === true && c === false) {
                        notifier.notify(scope.note, scope.ftype);
                        c = true;
                        if (scope.multi !== undefined) {
                            c = false;
                        }
                    }
                });
            }
        };
    }]);
    app.directive('smnImg', [function () {
        /* <img data-smn-img={{url}} >*/
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem, attrs) {
                attrs.$observe('smnImg', function (value) {
                    if (value === undefined || value.length === 0 || !value) {
                        value = 'assets/img/site/default/notf.jpg';
                    }
                    attrs.$set('src', value);
                });
                elem.bind('error', function () {
                    elem.attr('src', 'assets/img/site/default/notf.jpg');
                });
            }
        };
    }]);
    app.directive('smnSpinThatOnUpdate', [function () {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                scope.$on('up_news_s', function () {
                    elem.addClass('no-borders fa-spin');
                });
                scope.$on('up_news_e', function () {
                    elem.removeClass('no-borders fa-spin');
                });
            }
        };
    }]);
    app.directive('smnPushDownSlow', ['$timeout', '$anchorScroll', function ($timeout, $anchorScroll) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                $anchorScroll();
                $timeout(function () {
                    elem.addClass('top-row');
                }, 1500);
            }
        };
    }]);
    app.directive('smnNormalizeSpacing', ['$timeout', function ($timeout) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                $timeout(function () {
                    elem.removeClass('sick');
                }, 1500);
            }
        };
    }]);
    app.directive('smnSetUpLoad', ['$timeout', 'jQuery', function ($timeout, jQuery) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope) {
                function addHeight() {
                    jQuery('html, body').css('height', '100%');
                }
                function removeHeight() {
                    jQuery('html, body').css('height', '');
                }
                scope.$on('$routeChangeStart', function (next, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/') {
                            addHeight();
                        } else if (current.$$route.originalPath === '/home') {
                            addHeight();
                        } else if (current.$$route.originalPath === '/news') {
                            addHeight();
                        } else if (current.$$route.originalPath === '/news/:id') {
                            addHeight();
                        }
                    }
                });
                scope.$on('ch_view', function () {
                    addHeight();
                });
                scope.$on('ch_cp', function () {
                    $timeout(function () {
                        removeHeight();
                    }, 3500);
                });

            }
        };
    }]);
    app.filter("breaker", ['common_service', function (cv) {
        return function (data) {
            if (data !== undefined) {
                if (cv.is_touch_device() && cv.is_mobile_device()) {
                    return data.replace(/\n\r?/g, '<br/><br/>');
                }
                return data.replace(/\n\r?/g, '<br/>');
            }
            return data;
        };
    }]);
    var smnLeftNav = function ($scope, $timeout, menu, mm, jQuery) {
        $scope.$on('$routeChangeStart', function (next, current) {
            if (current.$$route) {
                mm.menu_op($scope);
            }
        });
        $scope.show_auth_modal = function () {
            var wait = 100;
            if (jQuery('.smnlfnav').hasClass('nav-open')) {
                $scope.left_btn.toggle_left_nav();
                menu.toggleLeft();
                wait = 700;
            }
            $timeout(function () {
                jQuery('#auth-modal').modal('show');
                $timeout(function () {
                    jQuery('#imail').focus();
                }, 500);
            }, wait);
        };
    };
    smnLeftNav.$inject = ['$scope', '$timeout', 'menu', 'modal_manager', 'jQuery'];
    app.directive('smnLeftNav', ['$timeout', 'menu', 'preferences', 'jQuery', 'notifier',
        function ($timeout, menu, pref, jQuery, notifier) {
            return {
                restrict: 'A',
                templateUrl: 'assets/public/directives/nav/leftnav.html',
                replace: true,
                controller: smnLeftNav,
                link: function (scope) {
                    scope.left_nav = {pref: undefined, show_auth_modal: scope.show_auth_modal, allow_hints: undefined,
                        change_style: undefined, col: {theme: true, link: true, hints: true}};
                    function set_app_pres() {
                        scope.left_nav.pref = pref.xget_pref();
                        if (scope.left_nav.pref === undefined) {
                            scope.left_nav.pref = {hints: false, nav_style: 'default'};
                            pref.xset_pref(scope.left_nav.pref);
                        }
                    }
                    set_app_pres();
                    scope.left_nav.change_style = function (style) {
                        scope.left_nav.pref.nav_style = style;
                        pref.xset_pref(scope.left_nav.pref);

                        var el = jQuery('.smnlfnav, .smnrtnav, .smn-border, .search-bg, #left-menu-toggle, #right-menu-toggle, .customize-nav');
                        if (style === 'default') {
                            el.removeClass('theme-smn theme-retro theme-ios theme-android');
                        } else if (style === 'theme-ios') {
                            el.removeClass('theme-smn theme-retro theme-android').addClass('theme-ios');
                        } else if (style === 'theme-android') {
                            el.removeClass('theme-smn theme-retro theme-ios').addClass('theme-android');
                        } else if (style === 'theme-retro') {
                            el.removeClass('theme-smn theme-ios theme-android').addClass('theme-retro');
                        } else if (style === 'theme-smn') {
                            el.removeClass('theme-ios theme-android theme-retro').addClass('theme-smn');

                        }
                        scope.left_nav.col.theme = true;
                    };

                    scope.left_nav.allow_hints = function () {

                        scope.left_nav.pref.hints = !scope.left_nav.pref.hints;
                        if (scope.left_nav.pref.hints) {
                            notifier.notify('Hints is on..');
                        } else {
                            notifier.notify('Hints is off..', 'warning');
                        }
                        pref.xset_pref(scope.left_nav.pref);
                        scope.left_nav.col.hints = true;
                    };

                    scope.left_nav.open_cl = function (cl) {
                        if (cl === 'theme') {
                            scope.left_nav.col.theme = !scope.left_nav.col.theme;
                            scope.left_nav.col.link = true;
                            scope.left_nav.col.hints = true;
                        } else if (cl === 'link') {
                            scope.left_nav.col.link = !scope.left_nav.col.link;
                            scope.left_nav.col.theme = true;
                            scope.left_nav.col.hints = true;
                        } else {
                            scope.left_nav.col.hints = !scope.left_nav.col.hints;
                            scope.left_nav.col.theme = true;
                            scope.left_nav.col.link = true;
                        }
                    };
                    scope.$on('user_prefs', function () {
                        set_app_pres();
                    });
                }
            };
        }]);
    var smnRightNav = function ($scope, mm) {
        $scope.$on('$routeChangeStart', function (next, current) {
            if (current.$$route) {
                mm.menu_op($scope);
            }
        });
    };
    smnRightNav.$inject = ['$scope', 'modal_manager'];
    app.directive('smnRightNav', ['preferences', '$rootScope', '$q', '$routeParams', 'modal_manager', 'notifier',
        function (pref, $rootScope, $q, $routeParams, mm, notifier) {
            return {
                restrict: 'A',
                templateUrl: 'assets/public/directives/nav/rightnav.html',
                replace: true,
                controller: smnRightNav,
                link: function (scope) {
                    scope.right_nav = {col: {cat: true, art: true, news: true, loc: true},
                        change_opening: undefined, allow_location: undefined, change_art_view: undefined, update: undefined,
                        search: undefined, filter: undefined, updating: false, pref: undefined, op_src: undefined};
                    function on_auth_active() {
                        var defer = $q.defer();
                        scope.$on('proceed', function () {
                            defer.resolve(1);
                        });
                        return defer.promise;
                    }

                    function set_app_pref() {
                        scope.right_nav.pref = pref.xget_pref();
                        if (scope.right_nav.pref.opening === undefined) {
                            scope.right_nav.pref.opening = 'modal';
                        }
                        if (scope.right_nav.pref.location === undefined) {
                            scope.right_nav.pref.location = false;

                        }
                        if (scope.right_nav.pref.location === true && pref.get_geo() === undefined) {
                            on_auth_active().then(function () {
                                scope.auth.set_location();
                            });
                        }
                        if (scope.right_nav.pref.art_view === undefined) {
                            scope.right_nav.pref.art_view = 'main_view';
                        }
                        if (scope.right_nav.pref.fsize === undefined) {
                            scope.right_nav.pref.fsize = 3;
                        }
                        if (scope.right_nav.pref.bcolor === undefined) {
                            scope.right_nav.pref.bcolor = 1;
                        }
                        if (scope.right_nav.pref.afont === undefined) {
                            scope.right_nav.pref.afont = 'n';
                        }
                        pref.xset_pref(scope.right_nav.pref);
                    }

                    set_app_pref();
                    scope.$on('user_prefs', function () {
                        set_app_pref();
                    });
                    scope.right_nav.change_opening = function (opening) {
                        scope.right_nav.pref.opening = opening;
                        pref.xset_pref(scope.right_nav.pref);
                        scope.right_nav.col.art = true;
                    };
                    scope.right_nav.allow_location = function () {
                        scope.right_nav.pref.location = !scope.right_nav.pref.location;
                        pref.xset_pref(scope.right_nav.pref);
                        scope.right_nav.col.loc = true;
                        if (!scope.right_nav.pref.location) {
                            notifier.notify('Your location is off...', 'warning');
                            pref.delete_geo('geo');
                            scope.$broadcast('delete_geo', function () {
                                return 1;
                            });
                        } else {
                            notifier.notify('Your location is on...');
                            scope.$broadcast('get_location', function () {
                                return 1;
                            });
                            scope.auth.set_location();
                        }
                    };
                    scope.right_nav.change_art_view = function (view) {
                        $rootScope.$broadcast('ch_view', function () {
                            return 1;
                        });
                        scope.right_nav.filter = '';
                        scope.right_nav.pref.art_view = view;
                        pref.xset_pref(scope.right_nav.pref);
                        scope.right_nav.col.news = true;
                    };
                    scope.right_nav.open_cl = function (cl) {
                        if (cl === 'cat') {
                            scope.right_nav.col.cat = !scope.right_nav.col.cat;
                            scope.right_nav.col.art = true;
                            scope.right_nav.col.news = true;
                            scope.right_nav.col.loc = true;
                        } else if (cl === 'art') {
                            scope.right_nav.col.art = !scope.right_nav.col.art;
                            scope.right_nav.col.cat = true;
                            scope.right_nav.col.news = true;
                            scope.right_nav.col.loc = true;
                        } else if (cl === 'news') {
                            scope.right_nav.col.news = !scope.right_nav.col.news;
                            scope.right_nav.col.art = true;
                            scope.right_nav.col.cat = true;
                            scope.right_nav.col.loc = true;
                        } else {
                            scope.right_nav.col.loc = !scope.right_nav.col.loc;
                            scope.right_nav.col.art = true;
                            scope.right_nav.col.news = true;
                            scope.right_nav.col.cat = true;
                        }

                    };
                    function update(a) {
                        scope.$broadcast('up_news_s', function () {
                            return a;
                        });
                    }

                    scope.right_nav.update = function () {
                        $rootScope.$broadcast('ch_view', function () {
                            return 1;
                        });
                        if (scope.right_nav.updating === false) {
                            if ($routeParams.id !== undefined) {
                                update(0);
                            } else {
                                update(1);
                                scope.right_nav.updating = true;
                            }
                        }
                    };
                    scope.$on('up_news_e', function () {
                        scope.right_nav.updating = false;
                    });
                    scope.$on('manual_geo', function () {
                        scope.right_nav.allow_location();
                    });

                    (function activate() {
                        $rootScope.$broadcast('right_nav', function () {
                            return 1;
                        });
                    }());
                    scope.right_nav.s_class = function () {
                        if (scope.right_nav.filter !== undefined) {
                            if (scope.right_nav.filter.length <= 3) {
                                return '';
                            } else if (scope.right_nav.filter.length > 3) {
                                return 'fa-spin';
                            }
                        } else {
                            return '';
                        }
                    };
                    scope.right_nav.search = function () {
                        $rootScope.$broadcast('filter', function () {
                            return scope.right_nav.filter;
                        });

                    };
                    scope.right_nav.op_src = function () {
                        mm.op_src(scope);
                        $rootScope.$broadcast('filter_m', function () {
                            return 1;
                        });
                    };
                }
            };
        }]);
    var smnLeftNavBtn = function ($scope, common_service, jQuery) {
        $scope.left_btn = {click: false, toggle_left_nav: undefined};
        $scope.left_btn.toggle_left_nav = function () {
            var btn = jQuery('#left-menu-toggle');
            if (!btn.hasClass('btn-close')) {
                btn.children('i').removeClass('fa-align-justify');
                btn.children('i').addClass('fa-align-right');
                if (common_service.is_mobile_device() || common_service.is_touch_device()) {
                    jQuery('body').removeClass('hide-overflow');
                }
                $scope.left_btn.click = false;

            } else if (btn.hasClass('btn-close')) {
                btn.children('i').removeClass('fa-align-right');
                btn.children('i').addClass('fa-align-justify');
                if (common_service.is_mobile_device() || common_service.is_touch_device()) {
                    jQuery('body').addClass('hide-overflow');
                }
                $scope.left_btn.click = true;
            }
            btn.toggleClass('btn-close');
        };
    };
    smnLeftNavBtn.$inject = ['$scope', 'common_service', 'jQuery'];
    app.directive('smnLeftNavBtn', ['menu', 'common_service', function (menu, common_service) {
        return {
            restrict: 'A',
            replace: true,
            controller: smnLeftNavBtn,
            link: function (scope, elem) {
                if (common_service.is_transform3d()) {
                    elem.click(function (event) {
                        event.stopPropagation();
                        scope.left_btn.toggle_left_nav();
                        menu.toggleLeft();
                    });
                }
            }
        };
    }]);
    var smnRightNavBtn = function ($scope, common_service, jQuery) {
        $scope.right_btn = {click: false, toggle_right_nav: undefined};
        $scope.right_btn.toggle_right_nav = function () {
            var btn = jQuery('#right-menu-toggle');
            if (!btn.hasClass('btn-close')) {
                btn.children('i').removeClass('fa-gears');
                btn.children('i').addClass('fa-gear');
                if (common_service.is_mobile_device() || common_service.is_touch_device()) {
                    jQuery('body').removeClass('hide-overflow');
                }
                $scope.right_btn.click = false;
            } else if (btn.hasClass('btn-close')) {
                btn.children('i').removeClass('fa-gear');
                btn.children('i').addClass('fa-gears');
                if (common_service.is_mobile_device() || common_service.is_touch_device()) {
                    jQuery('body').addClass('hide-overflow');
                }
                $scope.right_btn.click = true;

            }
            btn.toggleClass('btn-close');
        };
    };
    smnRightNavBtn.$inject = ['$scope', 'common_service', 'jQuery'];

    app.directive('smnRightNavBtn', ['menu', 'common_service',
        function (menu, common_service) {
            return {
                restrict: 'A',
                replace: true,
                controller: smnRightNavBtn,
                link: function (scope, elem) {
                    if (common_service.is_transform3d()) {
                        elem.click(function (event) {
                            event.stopPropagation();
                            scope.right_btn.toggle_right_nav();
                            menu.toggleRight();
                        });
                    }
                }
            };
        }]);

    app.directive('smnSwipeLeft', ['common_service', 'menu',
        function (common_service, menu) {
            return {
                restrict: 'A',
                replace: true,
                link: function (scope, elem) {
                    scope.swipe_left = {swipeRightToOpen: undefined, swipeLeftToClose: undefined};
                    if (common_service.is_mobile_device() || common_service.is_touch_device()) {
                        /*elem.addClass('drag-shadow-left');*/
                    }
                    scope.swipe_left.swipeRightToOpen = function () {
                        if (!scope.left_btn.click) {
                            scope.left_btn.toggle_left_nav();
                            menu.toggleLeft();
                            scope.left_btn.click = true;
                        }
                    };
                    scope.swipe_left.swipeLeftToClose = function () {
                        if (scope.left_btn.click) {
                            scope.left_btn.toggle_left_nav();
                            menu.toggleLeft();
                            scope.left_btn.click = false;
                        }
                    };
                }
            };
        }]);
    app.directive('smnSwipeRight', ['common_service', 'menu',
        function (common_service, menu) {
            return {
                restrict: 'A',
                replace: true,
                link: function (scope, elem) {
                    scope.swipe_right = {swipeLeftToOpen: undefined, swipeRightToClose: undefined};
                    if (common_service.is_mobile_device() || common_service.is_touch_device()) {
                        /*elem.addClass('drag-shadow-right');*/
                    }
                    scope.swipe_right.swipeLeftToOpen = function () {
                        if (!scope.right_btn.click) {
                            scope.right_btn.toggle_right_nav();
                            menu.toggleRight();
                            scope.right_btn.click = true;
                        }
                    };
                    scope.swipe_right.swipeRightToClose = function () {
                        if (scope.right_btn.click) {
                            scope.right_btn.toggle_right_nav();
                            menu.toggleRight();
                            scope.right_btn.click = false;
                        }
                    };
                }
            };
        }]);
    app.directive('smnAuth', ['$timeout', 'animation', 'jQuery', 'notifier', 'user_manager', 'preferences', 'menu', '$rootScope', 'page_manager',
        function ($timeout, animation, jQuery, notifier, user_manager, pref, menu, $rootScope, pm) {
            return {
                restrict: 'A',
                templateUrl: 'assets/public/directives/modal/auth.html',
                replace: true,
                link: function (scope) {
                    scope.auth = {auth: undefined, register: undefined, log_out: undefined, set_location: undefined,
                        show_profile: undefined, identity: undefined, location: undefined};
                    scope.auth.identity = user_manager.identify_user();

                    function start_request(elem) {
                        animation.toggle(elem);
                    }

                    function start_sm_request(elem, size) {
                        animation.toggle(elem, undefined, size);
                    }

                    function end_request(form, elem, addition, error) {
                        if (error === 0) {
                            form.$setPristine();
                            form.email = undefined;
                            form.password = undefined;
                        }
                        animation.toggle(elem, addition);
                    }

                    scope.auth.set_location = function () {

                        var allow = pref.xget_pref();
                        if (allow.location) {
                            user_manager.current_loc().then(function (location) {
                                pref.set_geo(location);
                                scope.$broadcast('location_on', function () {
                                    return 1;
                                });
                            });
                        }
                    };
                    function handle_request(result, form, elem, addition, action) {

                        if (result !== undefined) {
                            scope.auth.set_location();
                            $timeout(function () {
                                jQuery('#auth-modal').modal('hide');
                                end_request(form, elem, addition, 0);
                                $timeout(function () {
                                    if (action === 0) {
                                        notifier.notify('You have successfully signed in', 'success');
                                    } else if (action === 1) {
                                        notifier.notify('You have successfully registered and signed in', 'success');
                                    }
                                    scope.$broadcast('proceed', function () {
                                        return 1;
                                    });
                                }, 500);
                            }, 1500);
                        } else if (result === undefined) {
                            $timeout(function () {
                                end_request(form, elem, 'Try again', 1);
                                form.$valid = true;
                                if (action === 0) {
                                    notifier.notify('Wrong username or password', 'error');
                                } else if (action === 1) {
                                    notifier.notify('This email is already registered, please sing in', 'error');
                                } else if (action === -1) {
                                    notifier.notify('Something went very wrong', 'error');
                                }
                            }, 1500);
                            return 1;
                        }
                    }

                    function declare_identity(result) {
                        if (result !== undefined) {
                            scope.auth.identity = user_manager.identify_user();
                        }
                    }

                    scope.auth.auth = function (form) {
                        if (form !== undefined && form.$valid) {
                            if (form.email.length >= 7 && form.password.length >= 5) {
                                form.$valid = false;
                                start_request('#isub');
                                var user = {email: form.email, password: form.password}
                                user_manager.authenticate_user(user).
                                    then(function (result) {
                                        declare_identity(result);
                                        handle_request(result, form, '#isub', 'Sign In', 0);
                                        if (result !== undefined) {
                                            user.uid = result.uid;
                                            user_manager.get_user_prefs(user).then(function (r) {
                                                if (r !== undefined && r.prefs !== undefined && Object.keys(r.prefs).length >= 8) {
                                                    pref.xset_pref(r.prefs, 1).then(function (t) {
                                                        if (t === true) {
                                                            $rootScope.$broadcast('user_prefs', function () {
                                                                return 1;
                                                            });
                                                        }
                                                    } );
                                                }
                                            });
                                        }
                                    }, function () {
                                        handle_request(undefined, form, '#isub', 'Sign In', -1);
                                    }
                                );
                            }
                        }
                    };
                    scope.auth.register = function (form) {
                        if (form !== undefined && form.$valid) {
                            if (form.email.length >= 7 && form.password.length >= 5) {
                                form.$valid = false;
                                start_request('#usub');
                                user_manager.register_user({email: form.email, password: form.password}).
                                    then(function (result) {
                                        declare_identity(result);
                                        handle_request(result, form, '#usub', 'Sign Up', 1);
                                    }, function () {
                                        handle_request(undefined, form, '#usub', 'Sign Up', -1);
                                    }
                                );
                            }
                        }
                    };
                    scope.auth.log_out = function (action) {
                        user_manager.set_user_prefs(scope.auth.identity, pref.xget_pref());
                        var wait = 1500;
                        if (action === 1) {
                            start_sm_request('#alogout', 1);
                        } else {
                            animation.anima_i('#lflo', '', 'no-borders fa-spin fa-spinner');
                        }
                        user_manager.logout_user().
                            then(function (result) {
                                if (result === true) {
                                    if (pm.page_id() !== undefined) {
                                        pm.navigate('news');
                                    }
                                    $timeout(function () {
                                        scope.auth.identity = undefined;
                                        notifier.notify('You have successfully logged out', 'warning');
                                    }, wait);
                                }
                            }
                        );
                    };
                    scope.auth.show_profile = function () {

                        notifier.notify('Loading profile...');
                        user_manager.get_user_profile(scope.auth.identity).then(
                            function (response) {
                                scope.profile = response.profile;
                                scope.auth.location = pref.get_geo();
                                var wait = 100;
                                if (jQuery('.smnlfnav').hasClass('nav-open')) {
                                    scope.left_btn.toggle_left_nav();
                                    menu.toggleLeft();
                                    wait = 700;
                                }
                                $timeout(function () {
                                    jQuery('#profile-modal').modal('show');
                                    jQuery('#pfname').focus();
                                }, wait);
                            }, function () { notifier.notify('This request is unavailable at this moment', 'error'); }
                        );
                    };
                    (function proceed() {
                        $rootScope.$broadcast('proceed', function () {
                            return 1;
                        });
                    }());
                }
            };
        }]);

    app.directive('smnFlipper', ['jQuery', 'common_service', '$timeout', function (jQuery, common_service, $timeout) {
        return {
            restrict: 'A',
            replace: true,
            scope: { xplace: '='},
            link: function (scope, elem) {
                var formContainer, fid, id;
                if (scope.xplace === 0) {
                    fid = '#formContainer';
                    id = '#umail';
                } else if (scope.xplace === 1) {
                    fid = '#formContainer';
                    id = '#imail';
                } else {
                    fid = '#xformContainer';
                    id = '#pfname';
                }
                elem.click(function (event) {
                    event.preventDefault();
                    formContainer = jQuery(fid);
                    formContainer.toggleClass('flipped');
                    if (!common_service.is_transform3d()) {
                        jQuery('#login').toggle();
                    }
                    $timeout(function () {
                        jQuery(id).focus();
                    }, 1000);
                });
            }
        };
    }]);

    app.directive('smnProfile', ['$timeout', 'animation', 'user_manager', 'constant_service', 'notifier',
        function ($timeout, animation, user_manager, cs, notifier) {
            return {
                restrict: 'A',
                templateUrl: 'assets/public/directives/modal/profile.html',
                replace: true,
                link: function (scope) {


                    scope.pf = {switch_m: undefined, save: undefined, col: {inf: false, edi: true}};

                    scope.days = cs.numbers(1, 31);
                    scope.months = cs.numbers(1, 12);
                    scope.years = cs.numbers(1900, 2000);
                    scope.occ = cs.app_occ();

                    scope.pf.switch_m = function (mode) {

                        if (mode === 1) {
                            scope.pf.col.inf = !scope.pf.col.inf;
                            $timeout(function () {
                                scope.pf.col.edi = !scope.pf.col.edi;
                            }, 300);
                        } else {
                            scope.pf.col.edi = !scope.pf.col.edi;
                            $timeout(function () {
                                scope.pf.col.inf = !scope.pf.col.inf;
                            }, 300);
                        }
                    };
                    function set_bd(p) {
                        return p.day + '/' + p.month + '/' + p.year;
                    }

                    scope.pf.save = function (form, profile) {
                        if (form.$valid) {
                            animation.toggle('#pfsub', undefined, 1);
                            notifier.notify('Updating profile...', 'warning');
                            profile.birthday.bd = set_bd(profile.birthday);
                            user_manager.set_user_profile(scope.auth.identity, profile).
                                then(function (result) {
                                    if (result === 1) {
                                        notifier.notify('Your profile is now updated');
                                        $timeout(function () {
                                            scope.pf.switch_m();
                                            $timeout(function () {
                                                animation.toggle('#pfsub', 'SAVE');
                                            }, 100);
                                        }, 300);
                                    }
                                });
                        }
                    };
                }
            };
        }]);
    app.directive('smnStatusModal', [ 'modal_manager',
        function (mm) {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/modal/status.html',
                link: function (scope) {
                    scope.yes = function () {
                        mm.cl_stat();
                    };
                }
            };
        }]);
    app.directive('smnMainView', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/view/main.html',
                scope: {articles: '=', xopen: '=', hd: '=', xtrim: '='}
            };
        }]);
    app.directive('smnMainViewSecond', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/view/main2.html',
                scope: {articles: '=', xopen: '=', hd: '=', xtrim: '='}
            };
        }]);
    app.directive('smnNewsCoolPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                scope: {articles: '=', xtrim: '=', xopen: '='},
                templateUrl: 'assets/public/directives/news/parts/cool_part.html',
                link: function (scope) {
                    scope.cool_filter = '';
                    scope.$on('filter', function (e, s) {
                        scope.cool_filter = s();
                    });
                }
            };
        }]);
    app.directive('smnNewsCoolView', [function () {
        return {
            restrict: 'A',
            replace: false,
            templateUrl: 'assets/public/directives/news/view/cool.html',
            scope: {articles: '=', xtrim: '=', xopen: '='}
        };
    }]);
    app.directive('smnNewsImgPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/parts/img_part.html',
                scope: {articles: '=', xopen: '='},
                link: function (scope) {
                    scope.img_filter = '';
                    scope.$on('filter', function (e, s) {
                        scope.img_filter = s();
                    });
                }
            };
        }]);
    app.directive('smnNewsImgView', [function () {
        return {
            restrict: 'A',
            replace: false,
            templateUrl: 'assets/public/directives/news/view/img.html',
            scope: {articles: '=', xopen: '='}
        };
    }]);
    app.directive('smnNewsGartPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/parts/gart_part.html',
                scope: {articles: '=', xopen: '=', xtrim: "="},
                link: function (scope) {
                    scope.gart_filter = '';
                    scope.$on('filter', function (e, s) {
                        scope.gart_filter = s();
                    });
                }
            };
        }]);
    app.directive('smnNewsGartView', [function () {
        return {
            restrict: 'A',
            replace: false,
            templateUrl: 'assets/public/directives/news/view/gart.html',
            scope: {articles: '=', xopen: '=', xtrim: "="}
        };
    }]);
    app.directive('smnNewsDetailsPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/parts/detail_part.html',
                scope: {articles: '=', xtrim: "=", xopen: '='},
                link: function (scope) {
                    scope.d_filter = '';
                    scope.$on('filter', function (e, s) {
                        scope.d_filter = s();
                    });
                }
            };
        }]);
    app.directive('smnNewsDetailsView', [function () {
        return {
            restrict: 'A',
            replace: false,
            templateUrl: 'assets/public/directives/news/view/detail.html',
            scope: {articles: '=', xtrim: "=", xopen: '='}
        };
    }]);
    app.directive('smnNewsCarouselPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/parts/carousel.html',
                scope: {hd: '=', xtrim: '=', xopen: '='}
            };
        }]);
    app.directive('smnNewsSpinPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/parts/spin.html'
            };
        }]);
    app.directive('smnNewsLoadingPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/parts/loading.html'
            };
        }]);
    app.directive('smnErrorArticlePage', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/article/error.html'
            };
        }]);
    app.directive('smnArticleModal', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                scope: {art: '=', xbreaks: '=', xtrim: '=', xflag: '='},
                templateUrl: 'assets/public/directives/news/article/modal.html'
            };
        }]);
    app.directive('smnArticleTagsList', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                scope: { tags: '='},
                templateUrl: 'assets/public/directives/news/article/tags.html'
            };
        }]);
    app.directive('smnArticleContent', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                scope: { art: '=', xbreaks: '=', xtrim: '='},
                templateUrl: 'assets/public/directives/news/article/content.html'
            };
        }]);
    app.directive('smnNewsListPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/parts/list_part.html',
                scope: {articles: '=', xopen: '='},
                link: function (scope) {
                    scope.li_filter = '';
                    scope.$on('filter', function (e, s) {
                        scope.li_filter = s();
                    });
                }
            };
        }]);
    app.directive('smnNewsListView', [function () {
        return {
            restrict: 'A',
            replace: false,
            templateUrl: 'assets/public/directives/news/view/list.html',
            scope: {articles: '=', xopen: '='}
        };
    }]);
    app.directive('smnArticleRater', [
        function () {
            return {
                restrict: 'A',
                replace: false,
                templateUrl: 'assets/public/directives/news/article/rate.html',
                link: function (s) {
                }
            };
        }]);
    app.directive('smnHideInPage', ['page_manager', function (page_manager) {
        return {
            restrict: 'A',
            replace: true,
            link: function (s, elem) {
                var id = page_manager.page_id();
                if (id !== undefined) {
                    elem.hide();
                }
            }
        };
    }]);
    app.directive('smnModalXStatus', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                link: function (scope, elem) {
                    scope.modal_status = {open: undefined};
                    scope.modal_status.open = function () {
                        elem.modal('show');
                    };
                    scope.$broadcast('status', function () {
                        return 1;
                    });
                    scope.$on('$routeChangeStart', function () {
                        elem.modal('hide');
                    });
                }
            };
        }]);
    app.directive('smnReadArticle', ['news_manager',
        function (news_manager) {
            return {
                restrict: 'A',
                replace: true,
                scope: {axid: '=', xtype: '@'},
                link: function (scope, elem) {
                    function run() {
                        if (news_manager.is_read(scope.axid) === true) {
                            if (scope.xtype === '1') {
                                elem.addClass('fa-check');
                                elem.removeClass('fa-chevron-right');
                            } else if (scope.xtype === '2') {
                                elem.addClass('fa-plus');
                                elem.removeClass('fa-minus');
                            }

                        } else {
                            if (scope.xtype === '1') {
                                elem.addClass('fa-chevron-right');
                            } else if (scope.xtype === '2') {
                                elem.addClass('fa-minus');
                            }
                        }
                    }

                    scope.$on('finally', function () {
                        run();
                    });
                    run();
                }
            };
        }]);
    app.directive('smnArticleModalDialog', [
        function () {
            return {
                restrict: 'A',
                replace: false,
                link: function (scope, elem) {
                    scope.$on('$routeChangeStart', function () {
                        elem.modal('hide');
                    });
                    elem.on('hidden.bs.modal', function () {
                        scope.$broadcast('done', function () {
                            return 0;
                        });
                    });
                }
            };
        }]);
    app.directive('smnArticlePage', ['$rootScope',
        function () {
            return {
                restrict: 'A',
                replace: true,
                scope: {art: '=', xbreaks: '=', xtrim: '=', xflag: '='},
                templateUrl: 'assets/public/directives/news/article/article.html',
                link: function (scope) {
                    scope.xflag = true;
                    scope.$on('$destroy', function () {
                        scope.$broadcast('done', function () {
                            return 1;
                        });
                    });
                }
            };
        }]);
    app.directive('smnNewsCarousel', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                link: function (scope, elem) {
                    angular.element('.swipe-area').addClass('smn-c');
                    elem.carousel({interval: 10000, cycle: true});
                    scope.activeLi = function (index) {
                        return index === 0 ? 'active' : '';
                    };
                    scope.activeIt = function (index) {
                        return index === 0 ? 'item active' : 'item';
                    };
                    scope.prev = function () {
                        elem.carousel('prev');
                    };
                    scope.next = function () {
                        elem.carousel('next');
                    };
                    scope.$on('$destroy', function () {
                        angular.element('.swipe-area').removeClass('smn-c');
                    });
                }
            };
        }]);
    app.directive('smnArticleRatePanel', ['jQuery', 'hotWire', 'news_manager',
        function (jQuery, hotWire, nm) {
            return {
                restrict: 'A',
                replace: true,
                scope: {xaid: '='},
                link: function (scope, elem) {
                    function set_rating(ob, nx) {
                        var allStars = 5,
                            numStars = ob !== undefined ? jQuery(ob).nextUntil().length + 1 : nx,
                            rest = allStars - numStars,
                            i,
                            current,
                            j,
                            f = false,
                            k = 0,
                            es = jQuery('#1');

                        if (numStars === 1 && !es.hasClass('rsx')) {
                            f = true;
                        }
                        for (j = 1; j <= numStars; j++) {
                            jQuery('#' + j).addClass('rsx');
                        }
                        for (i = 5; i > (allStars - rest); i--) {
                            current = jQuery('#' + i);
                            if (current.hasClass('rsx')) {
                                k = (k + 1);
                                current.removeClass('rsx');
                            }
                        }
                        if (numStars === 1 && es.hasClass('rsx') && !f && k === 0) {
                            jQuery('#1').removeClass('rsx');
                            numStars = 0;
                        }

                        hotWire.event.rating = numStars;
                        if (ob !== undefined) {
                            nm.save_rate(scope.xaid, numStars);
                        }

                    }

                    function auto_rate() {
                        var r = nm.get_rate(hotWire.event.article_id), s = elem.attr('id'), i = parseInt(s, 0);
                        if (i <= r) {
                            set_rating(undefined, r);
                        }
                    }

                    auto_rate();
                    elem.on("click", function (event) {
                        event.preventDefault();
                        event.stopPropagation();
                        set_rating(this);
                    });
                    scope.$on('done', function () {
                        elem.removeClass('rsx');
                    });
                    scope.$on('reads', function () {
                        auto_rate();
                    });
                }
            };
        }]);
    app.directive('smnArticleTimer', ['timer_service', '$interval', 'hotWire', '$rootScope','$location',
        function (ts, $interval, hotWire, $rootScope, $location) {
            return {
                restrict: 'A',
                replace: false,
                scope: {xflag: '='},
                link: function (scope, elm) {
                    function start() {
                        scope.startTime = new Date().getTime();
                        hotWire.event.timestamp = scope.startTime;
                        scope.timer = $interval(function () {
                            scope.seconds = (new Date().getTime() - scope.startTime);
                            elm.text(ts.time(scope.seconds));
                            hotWire.event.time_spent = scope.seconds;
                            if (scope.seconds >= 300000) {
                                finish();
                                $location.path('news');
                            }
                        }, 1000);
                    }

                    function finish() {
                        scope.xflag = false;
                        if (angular.isDefined(scope.timer)) {
                            $interval.cancel(scope.timer);
                        }
                        elm.text('00:00:00');
                        $rootScope.$broadcast('finally', function () {
                            return 1;
                        });
                    }

                    scope.$watch('xflag', function (nval) {
                        if (nval === true) {
                            start();
                        }
                    });
                    scope.$on('done', function () {
                        finish();
                    });
                }
            };
        }]);
    app.directive('smnArticlePrefSize', ['preferences',
        function (pref) {
            return {
                restrict: 'A',
                replace: true,
                scope: {},
                link: function (scope, elem) {
                    function run() {
                        var size = pref.xget_pref();
                        if (size !== undefined && size.fsize !== undefined) {
                            elem.css('font-size', pref.font_pref(size.fsize));
                        }
                    }

                    run();
                    scope.$on('size', function () {
                        run();
                    });
                    scope.$on('user_prefs', function () {
                        run();
                    });
                }
            };
        }]);
    app.directive('smnArticleContentBig', ['preferences', '$rootScope',
        function (pref, $rootScope) {
            return {
                restrict: 'A',
                replace: true,
                scope: {},
                link: function (scope, elem) {
                    scope.c = 0;
                    function change() {
                        var prefs = pref.xget_pref(), t;
                        if (prefs !== undefined && prefs.fsize !== undefined && prefs.fsize < 8) {
                            t = prefs.fsize;
                            t = (t + 1);
                            prefs.fsize = t;
                            pref.xset_pref(prefs);
                            $rootScope.$broadcast('size', function () {
                                return 1;
                            });
                            scope.c = scope.c + 1;
                        }
                    }

                    elem.on('click', function () {
                        change();
                    });
                    scope.$watch('c', function () {
                    });
                    scope.$on('user_prefs', function () {
                        change();
                    });
                }
            };
        }]);
    app.directive('smnArticleContentSmall', ['$rootScope', 'preferences',
        function ($rootScope, pref) {
            return {
                restrict: 'A',
                replace: false,
                scope: {},
                link: function (scope, elem, attrs) {
                    scope.c = 0;
                    function change() {
                        var prefs = pref.xget_pref(), t;
                        if (prefs !== undefined && prefs.fsize !== undefined && prefs.fsize > 1) {
                            t = prefs.fsize;
                            t = (t - 1);
                            prefs.fsize = t;
                            pref.xset_pref(prefs);
                            $rootScope.$broadcast('size', function () {
                                return 1;
                            });
                            scope.c = scope.c + 1;
                        }
                    }

                    elem.on('click', function () {
                        change();
                    });
                    scope.$watch('c', function () {
                    });
                    scope.$on('user_prefs', function () {
                        change();
                    });
                }
            };
        }]);
    app.directive('smnArticleBgChanger', ['preferences', '$rootScope',
        function (pref, $rootScope) {
            return {
                restrict: 'A',
                replace: true,
                link: function (scope, elem) {
                    function change() {
                        var prefs = pref.xget_pref();
                        if (prefs !== undefined && prefs.bcolor !== undefined) {
                            if ((prefs.bcolor === 1)) {
                                prefs.bcolor = 2;
                            } else if (prefs.bcolor === 2) {
                                prefs.bcolor = 3;
                            } else if (prefs.bcolor === 3) {
                                prefs.bcolor = 4;
                            } else if (prefs.bcolor === 4) {
                                prefs.bcolor = 5;
                            } else if (prefs.bcolor === 5) {
                                prefs.bcolor = 1;
                            }
                            pref.xset_pref(prefs);
                            $rootScope.$broadcast('color', function () {
                                return 1;
                            });
                        }
                    }

                    elem.on('click', function () {
                        change();
                    });
                    scope.$on('user_prefs', function () {
                        change();
                    });
                }
            };
        }]);
    app.directive('smnArticlePrefColor', ['preferences', 'Math',
        function (pref) {
            return {
                restrict: 'A',
                replace: true,
                scope: {ctype: '='},
                link: function (scope, elem) {
                    function removeAll() {
                        elem.removeClass('xa-a xa-b xa-c xa-d xa-e');
                    }

                    function run() {
                        var prefs = pref.xget_pref();
                        if (prefs !== undefined && prefs.bcolor !== undefined) {
                            if ((prefs.bcolor === 1)) {
                                removeAll();
                                elem.addClass('xa-a');
                            } else if (prefs.bcolor === 2) {
                                removeAll();
                                elem.addClass('xa-b');
                            } else if (prefs.bcolor === 3) {
                                removeAll();
                                elem.addClass('xa-c');
                            } else if (prefs.bcolor === 4) {
                                removeAll();
                                elem.addClass('xa-d');
                            } else if (prefs.bcolor === 5) {
                                removeAll();
                                elem.addClass('xa-e');
                            }
                        }
                    }

                    run();
                    scope.$on('color', function () {
                        run();
                    });
                    scope.$on('user_prefs', function () {
                        run();
                    });
                }
            };
        }]);
    app.directive('smnShareArticle', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/article/share.html'
            };
        }]);
    app.directive('smnTwitterShare', ['page_manager', 'hotWire', function (pm, hw) {
        return {
            restrict: 'A',
            replace: true,
            template: '<i class="fa fa-twitter-square fa-3x twitter smn-time pointer" data-smn-scale-that data-text="Smart media news"></i>',
            link: function (s, elem) {
                elem.sharrre({
                    share: {
                        twitter: true
                    },
                    enableHover: false,
                    enableCounter: false,
                    template: '<div></div>',
                    click: function (api, options) {
                        options.url = pm.share_link(hw.event.article_id);
                        api.simulateClick();
                        api.openPopup('twitter');
                    }
                });
            }
        };
    }]);
    app.directive('smnLinkedInShare', ['page_manager', 'hotWire', function (pm, hw) {
        return {
            restrict: 'A',
            replace: true,
            template: '<i class="fa fa-linkedin-square fa-3x linkedin smn-time pointer" data-smn-scale-that data-text="Smart media news"></i>',
            link: function (s, elem) {
                elem.sharrre({
                    share: {
                        linkedin: true
                    },
                    enableHover: false,
                    enableCounter: false,
                    template: '<div></div>',
                    click: function (api, options) {
                        options.url = pm.share_link(hw.event.article_id);
                        api.simulateClick();
                        api.openPopup('linkedin');
                    }
                });
            }
        };
    }]);
    app.directive('smnGooglePlusShare', ['page_manager', 'hotWire', function (pm, hw) {
        return {
            restrict: 'A',
            replace: true,
            template: '<i class="fa fa-google-plus-square fa-3x googleplus smn-time pointer" data-smn-scale-that data-text="Smart media news"></i>',
            link: function (s, elem) {
                elem.sharrre({
                    share: {
                        googlePlus: true
                    },
                    enableHover: false,
                    enableCounter: false,
                    template: '<div></div>',
                    click: function (api, options) {
                        options.buttons.googlePlus.url = pm.share_link(hw.event.article_id);
                        api.simulateClick();
                        api.openPopup('googlePlus');
                    }
                });
            }
        };
    }]);
    app.directive('smnFacebookShare', ['page_manager', 'hotWire', function (pm, hw) {
        return {
            restrict: 'A',
            replace: true,
            template: '<i class="fa fa-facebook-square fa-3x facebook smn-time pointer" data-smn-scale-that data-text="Smart media news""></i>',
            link: function (s, elem) {
                elem.sharrre({
                    share: {
                        facebook: true
                    },
                    enableHover: false,
                    enableCounter: false,
                    template: '<div></div>',
                    click: function (api, options) {
                        options.buttons.facebook.url = pm.share_link(hw.event.article_id);
                        api.simulateClick();
                        api.openPopup('facebook');
                    }
                });
            }
        };
    }]);
    app.directive('smnArticlePanel', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/article/panel.html',
                scope: {xflag: '=', xaid: '=', art: '='},
                link: function (scope) {
                    function reset() {
                        scope.one = scope.two = scope.three = true;
                        scope.four = false;
                    }

                    reset();
                    scope.$on('done', function () {
                        reset();
                    });
                    scope.$on('reads', function () {
                        scope.four = true;
                    });
                    scope.$on('map_ready', function (e, s) {
                        var a = s();
                        if (a === 0) {
                            scope.four = true;
                        }
                    });
                    scope.$on('get_location', function () {
                        scope.four = false;
                    });
                }
            };
        }]);
    app.directive('smnGoogleMap', ['$rootScope', function ($rootScope) {
        return {
            restrict: 'A',
            replace: true,
            templateUrl: 'assets/public/directives/news/article/map.html',
            link: function (scope) {
                scope.turn_geo = function () {
                    $rootScope.$broadcast('manual_geo', function () {
                        return 1;
                    });
                };
            }
        };
    }]);
    var smnMapPart = function ($scope, prefs) {
        $scope.map_ctrl = {};
        $scope.markers = [];
        $scope.set_marker = function (m) {
            m.i = 'assets/img/site/default/home.png';
        };
        angular.forEach($scope.articles, function (v) {
            if (v.geo !== undefined && v.geo.length > 0) {
                angular.forEach(v.geo, function (vg) {
                    angular.forEach(vg, function (vl) {
                        $scope.markers.push(
                            {   cl: function () {
                                $scope.showart(this.model.options.a, true);
                            },
                                svl: false,
                                url: 'assets/public/directives/news/parts/map_label.html',
                                c: {latitude: vl[0], longitude: vl[1]},
                                events: $scope.events,
                                options: {
                                    title: v.src.title + ':\n' + v.src.leadText,
                                    a: v
                                }
                            }
                        );
                    });
                });
            }
        });
        function user_loc() {
            var loc = prefs.get_geo();
            if (loc !== undefined) {
                $scope.markers.push(
                    {i: 'assets/img/site/default/home.png',
                        c: {latitude: loc.latitude, longitude: loc.longitude },
                        sw: false, title: 'ME',
                        anchor: {x: 10, y: 10}}
                );
            }
        }

        user_loc();
        $scope.center = { latitude: 13.440227,
            longitude: 22.450947};
        $scope.zoom = 3;
        $scope.icon = '';
        $scope.bounds = { northeast: {latitude: 2.5404, longitude: -3.0928}, southwest: {latitude: 4.8863, longitude: -15.0264}};
        $scope.pan = false;
        $scope.anchor = {x: 10, y: 10};
        $scope.options = {
            disableDefaultUI: true,
            draggable: true,
            minZoom: 3
            /*zoomControl: false,
             scrollwheel: false,
             scaleControl: false,
             rotateControl: false,
             panControl: false,
             mapTypeControl: false,
             overviewMapControl: false,
             backgroundColor: 'red'*/
        };
        $scope.$on('delete_geo', function () {
            $scope.markers.pop();
        });
        $scope.$on('location_on', function () {
            user_loc();
        });
    };
    smnMapPart.$inject = ['$scope', 'preferences'];
    app.directive('smnMapPart', ['$rootScope', 'preferences', 'hotWire', function ($rootScope, prefs, hw) {
        return {
            restrict: 'A',
            replace: true,
            templateUrl: 'assets/public/directives/news/parts/map_part.html',
            scope: { articles: '=', showart: '='},
            controller: smnMapPart
        };
    }]);
    app.directive('smnNewsMapView', [function () {
        return {
            restrict: 'A',
            replace: true,
            templateUrl: 'assets/public/directives/news/view/world.html',
            scope: {articles: '=', xopen: '='}
        };
    }]);
    app.directive('smnSetSearch', ['$timeout', function ($timeout) {
        return {
            restrict: 'A',
            replace: false,
            link: function (scope, elem) {
                scope.$on('filter_m', function () {
                    $timeout(function () {
                        elem.focus();
                    }, 2000);
                });
            }
        };
    }]);
}());