(function () {
    'use strict';
    var app = angular.module('smnNg');
    app.controller('google_map', ['$scope', '$timeout', '$rootScope', 'preferences', function ($scope, $timeout, $rootScope, prefs) {
        var mapOptions = { disableDefaultUI: true, panControl: false, zoomControl: false, scaleControl: false, mapTypeControl: false, scrollwheel: false }, loc;
        $scope.map_r = true;
        $scope.map_c = {location: false, load: false};
        $scope.map_c.s_map = {center: {latitude: 63.415424, longitude: 10.408408}, zoom: 15, options: mapOptions};
        $scope.map_c.s_marker = {icon: 'assets/img/site/default/ntnu_logo.png', coords: {latitude: 63.415424, longitude: 10.408408}};

        function map_ready(a) {
            $rootScope.$broadcast('map_ready', function () {
                return a;
            });
        }
        function user_loc(a) {
            loc = prefs.get_geo();
            if (loc !== undefined) {
                $scope.map_c.a_map = {center: {latitude: loc.latitude || 63.415424, longitude: loc.longitude || 10.408408}, zoom: 10, options: mapOptions};
                $scope.map_c.a_marker = {icon: 'assets/img/site/default/home.png', coords: {latitude: loc.latitude || 63.415424, longitude: loc.longitude || 10.408408}};
                $scope.map_c.location = true;
                map_ready(a);
            } else if (loc === undefined) {
                $scope.map_c.location = false;
                map_ready(a);
            }
        }

        $timeout(function () {
            user_loc(0);
        }, 180);
        $scope.$on('delete_geo', function () {
            $scope.map_c.location = false;
            $scope.map_c.load = false;
        });
        $scope.$on('location_on', function () {
            $timeout(function () {
                user_loc(1);
            }, 180);
        });
        $scope.$on('get_location', function () {
            $scope.map_c.load = true;
        });
    }]);
    app.controller('shell', ['$scope', '$anchorScroll', function ($scope, $anchorScroll) {
        $anchorScroll();
        $scope.shell_ctrl = {};
    }]);
    app.controller('art_page', ['$scope', '$anchorScroll', '$timeout', function ($scope, $anchorScroll, $timeout) {
        $timeout(function () {
            $anchorScroll();
        }, 2000);
        $scope.goBack = function () {
            history.go(-1);
        };
    }]);
    app.controller('news', ['$scope', '$timeout', '$q', '$rootScope',
        'news_manager', 'art_utility', '$interval', 'page_manager', 'modal_manager', 'hotWire', 'event_manager', 'notifier',
        function ($scope, $timeout, $q, $rootScope, news_manager, art_utility, $interval, page_manager, modal_manager, hotWire, em, notifier) {

            $scope.utils = art_utility;
            $scope.n_ctrl = {division: undefined, art: undefined, modal: false, updating: false};
            $scope.flag = false;
            page_manager.anchor();
            function read_mod() {
                $rootScope.$broadcast('reads', function () {
                    return 1;
                });
            }

            function change_view(view, skip) {
                if (skip) {
                    $timeout(function () {
                        $scope.n_ctrl.division = view;
                    }, 1500);
                } else if (view !== 'article') {
                    $scope.n_ctrl.division = undefined;
                    $timeout(function () {
                        $scope.n_ctrl.division = view;
                    }, 1500);

                } else if (view === 'article') {
                    $scope.n_ctrl.division = view;
                }
                $rootScope.$broadcast('ch_cp', function () {
                    return 1;
                });
            }

            function nav_activate() {
                var defer = $q.defer();
                $scope.$on('right_nav', function () {
                    defer.resolve(1);
                });
                return defer.promise;
            }

            function default_view(skip) {
                if (page_manager.page_id() === undefined) {
                    modal_manager.menu_op($scope);
                    if ($scope.right_nav === undefined) {
                        nav_activate().then(function () {
                            change_view($scope.right_nav.pref.art_view, skip);
                        });
                    } else if ($scope.right_nav !== undefined) {
                        change_view($scope.right_nav.pref.art_view, skip);
                    }
                }
            }

            function proceed() {
                var defer = $q.defer();
                $scope.$on('proceed', function () {
                    defer.resolve(1);
                });
                return defer.promise;
            }

            function db_ready() {
                var defer = $q.defer();
                $scope.$on('ready_db', function () {
                    defer.resolve(1);
                });
                return defer.promise;
            }

            function status() {
                var defer = $q.defer();
                $scope.$on('status', function () {
                    defer.resolve(1);
                });
                return defer.promise;
            }

            function article(art) {
                read_mod();
                change_view('article');
                news_manager.save_art(art.src.articleId);
            }

            function set_article(art) {
                $scope.n_ctrl.art = art;
                hotWire.art = art;
                if ($scope.auth === undefined) {
                    proceed().then(function () {
                        if ($scope.auth.identity === undefined) {
                            status().then(function () {
                                $scope.modal_status.open();
                                proceed().then(function () {
                                    article(art);
                                });
                            });
                        } else if ($scope.auth.identity !== undefined) {
                            article(art);
                        }
                    });
                } else {
                    article(art);
                }

            }

            function get_more_articles() {
                var defer = $q.defer();
                news_manager.fetch($scope.articles.length + 50).then(function (news) {
                    if (news && news.length > 0) {
                        defer.resolve(news);
                    } else {
                        defer.resolve(undefined);
                    }
                });
                return defer.promise;
            }

            function get_news(skip) {
                news_manager.fetch(50).then(function (news) {
                    if (news && news.length > 0) {
                        $scope.articles = news;
                        $scope.hd = news_manager.select_img();
                        hotWire.articles = $scope.articles;
                        hotWire.hd = $scope.hd;
                        default_view(skip);
                    } else {
                        notifier.notify('Unavailable service...', 'error');
                        $timeout(function () {
                            page_manager.navigate('home/');
                        }, 2000);
                    }
                });
            }

            if (hotWire.articles !== undefined && hotWire.hd !== undefined) {
                $scope.articles = hotWire.articles;
                $scope.hd = hotWire.hd;
                default_view();
            } else if (hotWire.flag === true) {
                db_ready().then(function () {
                    get_news();
                });
            } else if (($scope.articles === undefined || $scope.hd === undefined)) {
                if (news_manager.empty_db() || news_manager.passed_time()) {
                    notifier.notify('Updating news...');
                    news_manager.start_fetch(news_manager.passed_time()).then(function (response) {
                        if (response && response.length > 0) {
                            get_news();
                        } else {
                            notifier.notify('Unavailable service...', 'error');
                            $timeout(function () {
                                page_manager.navigate('home/');
                            }, 2000);
                        }
                    });
                } else {
                    get_news();
                }
            }

            if (page_manager.page_id() !== undefined) {
                if (hotWire.art === undefined) {
                    news_manager.lc_art_id(page_manager.page_id()).then(function (lart) {
                        if (lart === undefined) {
                            news_manager.sv_art_id(page_manager.page_id()).then(function (sart) {
                                if (sart === undefined) {
                                    change_view('error');
                                } else {
                                    set_article(sart);
                                }
                            });
                        } else {
                            set_article(lart);
                        }
                    });
                } else {
                    set_article(hotWire.art);
                }
            }
            hotWire.flag = false;
            $scope.$watch('right_nav.pref.art_view', function (nval, oval) {
                if (nval !== oval) {
                    $rootScope.$broadcast('ch_cp', function () {
                        return 1;
                    });
                    modal_manager.menu_op($scope);
                    change_view(nval);
                }
            });
            $scope.$watch('auth.identity', function (nval, oval) {
                if (nval !== oval && nval !== undefined) {
                    hotWire.event.user_id = nval.uid;
                }
            });
            $scope.$watch('n_ctrl.art', function (nval, oval) {
                if (nval) {
                    hotWire.event.article_id = nval.src.articleId;
                    read_mod();
                }
            });
            function compete_update(u) {
                $rootScope.$broadcast('up_news_e', function () {
                    return u;
                });
            }

            $scope.$on('up_news_s', function (ev, sn) {
                $rootScope.$broadcast('ch_view', function () {
                    return 1;
                });
                var action = sn();
                notifier.notify('Updating news...', 'warning');
                $scope.n_ctrl.division = undefined;
                news_manager.update().then(function (res) {
                    if (res && res.length > 0) {
                        if (action === 1) {
                            get_news();
                        } else if (action === 0) {
                            get_news(1);
                        }
                        notifier.notify('News are updated...');
                        compete_update(1);
                    } else {
                        notifier.notify('Unavailable service...', 'error');
                        compete_update(0);
                        $timeout(function () {
                            page_manager.navigate('home/');
                        }, 2000);
                    }
                });
            });
            $scope.$on('end_page', function () {
                $scope.n_ctrl.updating = true;
                get_more_articles().then(function (news) {
                    $timeout(function () {
                        $scope.n_ctrl.updating = false;
                        if (news !== undefined) {
                            $scope.articles = $scope.articles.concat(news);
                            hotWire.articles = $scope.articles;
                        }

                    }, 3000);
                });
            });

            $scope.$on('finally', function () {
                $scope.n_ctrl.modal = false;
                em.add_rating($scope.auth.identity, hotWire.event).then(function (r) {
                    if (r) {
                        $scope.n_ctrl.art = undefined;
                        hotWire.event.article_id = undefined;
                        hotWire.event.timestamp = undefined;
                        hotWire.event.time_spent = undefined;

                    }

                });
            });
            function mode(art, force) {

                hotWire.art = art;
                if ($scope.right_nav.pref.opening === 'neww' || force === true) {
                    page_manager.new_page(art.src.articleId);
                    $scope.n_ctrl.modal = false;
                } else if ($scope.right_nav.pref.opening === 'page') {
                    $scope.n_ctrl.modal = false;
                    page_manager.navigate('news/' + art.src.articleId);
                } else if ($scope.right_nav.pref.opening === 'modal') {
                    $scope.n_ctrl.art = art;
                    $scope.n_ctrl.modal = true;
                    modal_manager.op_art($scope);
                    $scope.flag = true;
                    news_manager.save_art(art.src.articleId);
                }
            }

            $scope.xopen = function (art, f) {
                if ($scope.auth.identity === undefined) {
                    modal_manager.op_sta($scope);
                    proceed().then(function () {
                        mode(art, f);
                    });
                } else if ($scope.auth.identity !== undefined) {
                    mode(art, f);
                }
            };
        }]);
}());