(function () {
    'use strict';
    var app = angular.module('smnNg');
    app.directive('smnViewHandlerDefault', ['$timeout', 'jQuery', function ($timeout, jQuery) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                scope.$on('$routeChangeStart', function (next, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/home') {
                            $timeout(function () {
                                elem.fadeIn(2000);
                            }, 2000);
                            jQuery('html, body').addClass('html-body');
                        } else if (current.$$route.originalPath === '/news') {
                            $timeout(function () {
                                elem.fadeIn(2000);
                            }, 2000);
                            $timeout(function () {
                                jQuery('html, body').removeClass('html-body');
                            }, 8000);
                        } else if (current.$$route.originalPath === '/news/:id') {
                            jQuery('html, body').addClass('html-body');
                        } else if (current.$$route.originalPath === '/') {
                            elem.hide();
                            jQuery('html, body').addClass('html-body');
                        }
                    }
                });
                scope.$on('$routeChangeSuccess', function (event, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/home') {
                            $timeout(function () {
                                elem.fadeIn(2000);
                            }, 2000);
                        } else if (current.$$route.originalPath === '/news') {
                            $timeout(function () {
                                elem.fadeIn(2000);
                            }, 2000);
                        } else if (current.$$route.originalPath === '/') {
                            elem.hide();
                        }
                    }
                });
            }
        };
    }]);

    app.directive('smnViewHandlerNews', ['$timeout', function ($timeout) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                scope.$on('$routeChangeStart', function (next, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/home') {
                            elem.hide();
                        } else if (current.$$route.originalPath === '/news') {
                            elem.hide();
                        } else if (current.$$route.originalPath === '/') {
                            elem.hide();
                        }
                    }
                });
                scope.$on('$routeChangeSuccess', function (event, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/home') {
                            elem.hide();
                        } else if (current.$$route.originalPath === '/news') {
                            $timeout(function () {
                                elem.fadeIn(2000);
                            }, 2000);
                        } else if (current.$$route.originalPath === '/') {
                            elem.hide();
                        }
                    }
                });
            }
        };
    }]);

    app.directive('smnNavViewHandlerHome', [function () {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                scope.$on('$routeChangeStart', function (event, next, cureent) {
                });
                scope.$on('$routeChangeSuccess', function (event, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/home') {
                            elem.show();
                        } else if (current.$$route.originalPath === '/news') {
                            elem.hide();
                        } else if (current.$$route.originalPath === '/news/:id') {
                            elem.show();
                        }
                    }
                });
            }
        };
    }]);
    app.directive('smnNavViewHandlerArticle', [function () {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                scope.$on('$routeChangeStart', function (event, next, cureent) {
                });
                scope.$on('$routeChangeSuccess', function (event, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/news/:id') {
                            elem.hide();
                        } else if (current.$$route.originalPath === '/news') {
                            elem.show();
                        }
                    }
                });
            }
        };
    }]);
    app.directive('smnNavViewHandlerNews', [function () {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                scope.$on('$routeChangeStart', function (event, next, cureent) {
                });
                scope.$on('$routeChangeSuccess', function (event, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/home') {
                            elem.hide();
                        } else if (current.$$route.originalPath === '/news') {
                            elem.show();
                        }
                    }
                });
            }
        };
    }]);
    app.directive('smnPortableOnly', ['common_service', function (cv) {
        return {
            restrict: 'A',
            replace: true,
            link: function (s, elem) {
                if (!cv.is_mobile_device() || !cv.is_touch_device()) {
                    elem.remove();
                }
            }
        };
    }]);
    app.directive('smnTooltip', [ function () {
        return {
            restrict: 'A',
            replace: true,
            scope: {},
            link: function (s, elem) {
                elem.tooltip();
            }
        };
    }]);
    app.directive('smnDesktopOnly', ['common_service', function (cv) {
        return {
            restrict: 'A',
            replace: true,
            link: function (s, elem) {
                if (cv.is_mobile_device() || cv.is_touch_device()) {
                    elem.remove();
                }
            }
        };
    }]);
    app.directive('smnOnDown', [function () {
        return {
            restrict: 'A',
            replace: true,
            link: function (s, elem, attr) {
                elem.on('keyup', function (e, v) {
                });
            }
        };
    }]);

    app.directive('smnBtPgBroadcast', ['$document', '$window', '$routeParams', function ($document, $window, $routeParams) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope) {
                angular.element($window).bind('scroll', function () {
                    if (angular.element($window).scrollTop() + angular.element($window).height() >= angular.element($document).height()) {
                        if ($routeParams.id === undefined &&
                            scope.right_nav !== undefined &&
                            scope.right_nav.pref !== undefined &&
                            scope.right_nav.pref.art_view !== 'world' &&
                            scope.n_ctrl.division !== undefined &&
                            scope.n_ctrl.updating === false &&
                            scope.n_ctrl.modal === false) {
                            scope.$broadcast('end_page', function () {
                                return 1;
                            });

                        }
                    }
                });
            }
        };
    }]);

    app.directive('smnTheme', ['preferences', function (pref) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                function run() {
                    var setting = pref.xget_pref();
                    if (setting !== undefined && setting.nav_style !== undefined) {
                        elem.addClass(setting.nav_style);
                    }
                }
                run();
                scope.$on('user_prefs', function () {
                    run();
                })
            }
        };
    }]);

    app.directive('smnSpin', ['common_service', function (cv) {
        return {
            restrict: 'A',
            replace: true,
            link: function (s, elem) {
                elem.spin({lines: 13, length: 1, width: 10, radius: 30, corners: 1, rotate: 0, direction: 1, speed: 1,
                    color: cv.random_colors(), trail: 80, shadow: true, hwaccel: false, zIndex: 2e9});
            }
        };
    }]);
    app.directive('smnRandomColor', ['common_service', function (cv) {
        return {
            restrict: 'A',
            replace: true,
            scope: {type: '='},
            link: function (s, elem) {
                var c = cv.random_colors();
                if (s.type === 1) {
                    elem.css('color', c);
                } else {
                    elem.css('background-color', c);
                }

            }
        };
    }]);
    app.directive('smnBackgroundColor', ['jQuery', function (jQuery) {
        return {
            restrict: 'A',
            replace: true,
            scope: {where: '='},
            link: function (s) {
                function add(c) {
                    jQuery('body').addClass(c);
                }

                function clean() {
                    jQuery('body').removeClass('a-bg-t m-bg-t m2-bg-t m3-bg-t m4-bg-t');
                }

                clean();
                if (s.where === 0) {
                    add('m-bg-t');
                } else if (s.where === 1) {
                    add('a-bg-t');
                } else if (s.where === 2) {
                    add('m2-bg-t');
                } else if (s.where === 3) {
                    add('m3-bg-t');
                } else if (s.where === 4) {
                    add('m4-bg-t');
                } else if (s.where === -1) { }
            }
        };
    }]);
    app.directive('smnScaleThis', [function () {
        return {
            restrict: 'A',
            replace: true,
            link: function (s, elem) {

                elem.hover(function () {
                    elem.toggleClass('smn-s-i');
                });
                elem.focus(function () {
                    elem.toggleClass('smn-s-i');
                });
            }
        };
    }]);
    app.directive('smnScaleThat', [function () {
        return {
            restrict: 'A',
            replace: true,
            link: function (s, elem) {

                elem.hover(function () {
                    elem.toggleClass('smn-s-ii');
                });
                elem.focus(function () {
                    elem.toggleClass('smn-s-ii');
                });
            }
        };
    }]);

    app.directive('smnHelp', ['preferences', 'notifier', function (pref, notifier) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                note: '=',
                multi: '=',
                ftype: '='
            },
            link: function (scope, elem) {
                var c = false, hints;
                elem.click(function (event) {
                    event.preventDefault();
                    event.stopPropagation();
                    hints = pref.xget_pref();
                    if (hints !== undefined && hints.hints === true && c === false) {
                        notifier.notify(scope.note, scope.ftype);
                        c = true;
                        if (scope.multi !== undefined) {
                            c = false;
                        }
                    }
                });
            }
        };
    }]);
    app.directive('smnImg', [function () {
        /* <img data-smn-img={{url}} >*/
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem, attrs) {
                attrs.$observe('smnImg', function (value) {
                    if (value === undefined || value.length === 0 || !value) {
                        value = 'assets/img/site/default/notf.jpg';
                    }
                    attrs.$set('src', value);
                });
                elem.bind('error', function () {
                    elem.attr('src', 'assets/img/site/default/notf.jpg');
                });
            }
        };
    }]);
    app.directive('smnSpinThatOnUpdate', [function () {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                scope.$on('up_news_s', function () {
                    elem.addClass('no-borders fa-spin');
                });
                scope.$on('up_news_e', function () {
                    elem.removeClass('no-borders fa-spin');
                });
            }
        };
    }]);
    app.directive('smnPushDownSlow', ['$timeout', '$anchorScroll', function ($timeout, $anchorScroll) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                $anchorScroll();
                $timeout(function () {
                    elem.addClass('top-row');
                }, 1500);
            }
        };
    }]);
    app.directive('smnNormalizeSpacing', ['$timeout', function ($timeout) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                $timeout(function () {
                    elem.removeClass('sick');
                }, 1500);
            }
        };
    }]);
    app.directive('smnSetUpLoad', ['$timeout', 'jQuery', function ($timeout, jQuery) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                function addHeight() {
                    jQuery('html, body').css('height', '100%');
                }

                function removeHeight() {
                    jQuery('html, body').css('height', '');
                }

                scope.$on('$routeChangeStart', function (next, current) {
                    if (current.$$route) {
                        if (current.$$route.originalPath === '/') {
                            addHeight();
                        } else if (current.$$route.originalPath === '/home') {
                            addHeight();
                        } else if (current.$$route.originalPath === '/news') {
                            addHeight();
                        } else if (current.$$route.originalPath === '/news/:id') {
                            addHeight();
                        }
                    }
                });
                scope.$on('ch_view', function () {
                    addHeight();
                });
                scope.$on('ch_cp', function () {
                    $timeout(function () {
                        removeHeight();
                    }, 2500);
                });

            }
        };
    }]);
    app.filter("breaker", ['common_service', function (cv) {
        return function (data) {
            if (data !== undefined) {
                if (cv.is_touch_device() && cv.is_mobile_device()) {
                    return data.replace(/\n\r?/g, '<br/><br/>');
                }
                return data.replace(/\n\r?/g, '<br/>');
            }
            return data;
        };
    }]);
}());