(function () {
    'use strict';
    var app = angular.module('smnNg');
    app.directive('smnShell', [
        function () {
            return {
                restrict: 'A',
                templateUrl: 'assets/public/directives/main/shell.html',
                replace: true
            };
        }]);
    app.directive('smnGreeting', ['$location', '$timeout', 'notifier', 'common_service',
        function ($location, $timeout, notifier, common_service) {
            return {
                restrict: 'A',
                templateUrl: 'assets/public/directives/main/greeting.html',
                replace: true,
                link: function (scope) {

                    scope.greeting = {main_logo: undefined};
                    scope.greeting.main_logo = common_service.random_logo();
                    var notify = [
                        {i: 'Preparing the application...', t: 'info'}
                    ];
                    if (scope.right_nav !== undefined && scope.right_nav.pref !== undefined) {
                        if (scope.right_nav.pref.location === true) {
                            notify.push({i: 'Location: On', t: 'info'});
                        } else {
                            notify.push({i: 'Location: Off', t: 'warning'});
                        }
                        if (scope.right_nav.pref.hints === true) {
                            notify.push({i: 'Hints: On', t: 'info'});
                        } else {
                            notify.push({i: 'Hints: Off', t: 'warning'});
                        }

                    }
                    var i = 0, progress_bar;
                    angular.forEach(notify, function (v) {
                        $timeout(function () {
                            notifier.notify(v.i, v.t);
                        }, i === 0 ? 500 : (i * 1500));
                        i++;
                    });
                    progress_bar = angular.element('.progress-bar');

                    function finish() {
                        if ($location.path() === '/') {
                            $location.url('home');
                        }
                    }

                    function changeBg(color) {
                        angular.element('html, body').css('background-color', color);
                    }

                    function progress() {
                        var cb = common_service.random_number(500), counter = 0,
                            countDown = function () {
                                counter = counter + 1;
                                if (counter === 11) {
                                    $timeout(function () {
                                        finish();
                                    }, 500);
                                } else {
                                    progress_bar.width(counter * 10 + "%");
                                    $timeout(function () {
                                        countDown();
                                    }, cb);
                                }
                            };
                        countDown();
                    }

                    function setupBg() {

                        var background_one = common_service.random_colors(),
                            background_two = common_service.random_colors();

                        while (background_two === background_one) {
                            background_two = common_service.random_colors();
                        }
                        changeBg(background_one);
                        progress_bar.css('background-color', background_two);
                    }

                    (function () {
                        setupBg();
                        $timeout(function () {
                            progress_bar.width(common_service.random_number(10) + "%");
                            var cb = common_service.random_number(500);
                            $timeout(function () {
                                progress();
                            }, cb);
                        }, 1000);

                    }());
                }
            };
        }]);
    app.directive('smnSlider', ['common_service', function (common_service) {
        return {
            restrict: 'A',
            templateUrl: 'assets/public/directives/main/slider.html',
            replace: true,
            link: function (scope) {
                scope.slider = {img: []};
                var path = 'assets/img/site/slider/', i = 1;
                if (common_service.is_mobile_device()) {
                    path = path + 'port/';
                } else if (!common_service.is_mobile_device()) {
                    path = path + 'desk/';
                }
                for (i; i < 8; i = (i + 1)) {
                    scope.slider.img.push(path + 'smn' + i + '.jpg');
                }
            }
        };
    }]);
    app.directive('smnSlide', ['$timeout', function ($timeout) {
        return {
            restrict: 'A',
            replace: true,
            link: function (scope, elem) {
                $timeout(function () {
                    elem.superslides(
                        {
                            play: 7000,
                            animation: 'fade',
                            animation_speed: 'slow',
                            animation_easing: 'linear',
                            pagination: false,
                            hashchange: false
                        }
                    );
                }, 10);
            }
        };

    }]);
}());