(function () {
    'use strict';
    var app = angular.module('smnNg');
    app.directive('smnLeftNav', ['$timeout', 'menu', 'preferences', 'jQuery', 'modal_manager',
        function ($timeout, menu, pref, jQuery, mm) {
            return {
                restrict: 'A',
                templateUrl: 'assets/public/directives/nav/leftnav.html',
                replace: true,
                controller: function ($scope) {
                    $scope.$on('$routeChangeStart', function (next, current) {
                        if (current.$$route) {
                            mm.menu_op($scope);
                        }
                    });
                    $scope.show_auth_modal = function () {
                        var wait = 100;
                        if (jQuery('.smnlfnav').hasClass('nav-open')) {
                            $scope.left_btn.toggle_left_nav();
                            menu.toggleLeft();
                            wait = 700;
                        }
                        $timeout(function () {
                            jQuery('#auth-modal').modal('show');
                            $timeout(function () {
                                jQuery('#imail').focus();
                            }, 500);
                        }, wait);
                    };
                },
                link: function (scope) {
                    scope.left_nav = {pref: undefined, show_auth_modal: scope.show_auth_modal, allow_hints: undefined,
                        change_style: undefined, col: {theme: true, link: true, hints: true}};

                    function set_app_pres() {
                        scope.left_nav.pref = pref.xget_pref();
                        if (scope.left_nav.pref === undefined) {
                            scope.left_nav.pref = {hints: false, nav_style: 'default'};
                            pref.xset_pref(scope.left_nav.pref);
                        }
                    }
                    set_app_pres();
                    scope.left_nav.change_style = function (style) {
                        scope.left_nav.pref.nav_style = style;
                        pref.xset_pref(scope.left_nav.pref);

                        var el = jQuery('.smnlfnav, .smnrtnav, .smn-border, .search-bg, #left-menu-toggle, #right-menu-toggle, .customize-nav');
                        if (style === 'default') {
                            el.removeClass('theme-smn theme-retro theme-ios theme-android');
                        } else if (style === 'theme-ios') {
                            el.removeClass('theme-smn theme-retro theme-android').addClass('theme-ios');
                        } else if (style === 'theme-android') {
                            el.removeClass('theme-smn theme-retro theme-ios').addClass('theme-android');
                        } else if (style === 'theme-retro') {
                            el.removeClass('theme-smn theme-ios theme-android').addClass('theme-retro');
                        } else if (style === 'theme-smn') {
                            el.removeClass('theme-ios theme-android theme-retro').addClass('theme-smn');

                        }
                        scope.left_nav.col.theme = true;
                    };

                    scope.left_nav.allow_hints = function () {

                        scope.left_nav.pref.hints = !scope.left_nav.pref.hints;
                        pref.xset_pref(scope.left_nav.pref);
                        scope.left_nav.col.hints = true;
                    };

                    scope.left_nav.open_cl = function (cl) {
                        if (cl === 'theme') {
                            scope.left_nav.col.theme = !scope.left_nav.col.theme;
                            scope.left_nav.col.link = true;
                            scope.left_nav.col.hints = true;
                        } else if (cl === 'link') {
                            scope.left_nav.col.link = !scope.left_nav.col.link;
                            scope.left_nav.col.theme = true;
                            scope.left_nav.col.hints = true;
                        } else {
                            scope.left_nav.col.hints = !scope.left_nav.col.hints;
                            scope.left_nav.col.theme = true;
                            scope.left_nav.col.link = true;
                        }
                    };
                    scope.$on('user_prefs', function () {
                        set_app_pres();
                    });
                }
            };
        }]);
    app.directive('smnRightNav', ['preferences', '$rootScope', '$q', '$routeParams', 'modal_manager', 'jQuery', '$timeout',
        function (pref, $rootScope, $q, $routeParams, mm, jQuery, $timeout) {
            return {
                restrict: 'A',
                templateUrl: 'assets/public/directives/nav/rightnav.html',
                replace: true,
                controller: function ($scope) {
                    $scope.$on('$routeChangeStart', function (next, current) {
                        if (current.$$route) {
                            mm.menu_op($scope);
                        }
                    });
                },
                link: function (scope) {
                    scope.right_nav = {col: {cat: true, art: true, news: true, loc: true},
                        change_opening: undefined, allow_location: undefined, change_art_view: undefined, update: undefined,
                        search: undefined, filter: undefined, updating: false, pref: undefined, op_src: undefined};
                    function on_auth_active() {
                        var defer = $q.defer();
                        scope.$on('proceed', function () {
                            defer.resolve(1);
                        });
                        return defer.promise;
                    }
                    function set_app_pref() {
                        scope.right_nav.pref = pref.xget_pref();
                        if (scope.right_nav.pref.opening === undefined) {
                            scope.right_nav.pref.opening = 'modal';
                        }
                        if (scope.right_nav.pref.location === undefined) {
                            scope.right_nav.pref.location = false;

                        }
                        if (scope.right_nav.pref.location === true && pref.get_geo() === undefined) {
                            on_auth_active().then(function () {
                                scope.auth.set_location();
                            });
                        }
                        if (scope.right_nav.pref.art_view === undefined) {
                            scope.right_nav.pref.art_view = 'gart';
                        }
                        if (scope.right_nav.pref.fsize === undefined) {
                            scope.right_nav.pref.fsize = 3;
                        }
                        if (scope.right_nav.pref.bcolor === undefined) {
                            scope.right_nav.pref.bcolor = 1;
                        }
                        if (scope.right_nav.pref.afont === undefined) {
                            scope.right_nav.pref.afont = 'n';
                        }
                        pref.xset_pref(scope.right_nav.pref);
                    }
                    set_app_pref();
                    scope.$on('user_prefs', function () {
                        set_app_pref();
                    });
                    scope.right_nav.change_opening = function (opening) {
                        scope.right_nav.pref.opening = opening;
                        pref.xset_pref(scope.right_nav.pref);
                        scope.right_nav.col.art = true;
                    };
                    scope.right_nav.allow_location = function () {
                        scope.right_nav.pref.location = !scope.right_nav.pref.location;
                        pref.xset_pref(scope.right_nav.pref);
                        scope.right_nav.col.loc = true;
                        if (!scope.right_nav.pref.location) {
                            pref.delete_geo('geo');
                            scope.$broadcast('delete_geo', function () {
                                return 1;
                            });
                        } else {
                            scope.$broadcast('get_location', function () {
                                return 1;
                            });
                            scope.auth.set_location();
                        }
                    };
                    scope.right_nav.change_art_view = function (view) {
                        $rootScope.$broadcast('ch_view', function () {
                            return 1;
                        });
                        scope.right_nav.filter = '';
                        scope.right_nav.pref.art_view = view;
                        pref.xset_pref(scope.right_nav.pref);
                        scope.right_nav.col.news = true;
                    };
                    scope.right_nav.open_cl = function (cl) {
                        if (cl === 'cat') {
                            scope.right_nav.col.cat = !scope.right_nav.col.cat;
                            scope.right_nav.col.art = true;
                            scope.right_nav.col.news = true;
                            scope.right_nav.col.loc = true;
                        } else if (cl === 'art') {
                            scope.right_nav.col.art = !scope.right_nav.col.art;
                            scope.right_nav.col.cat = true;
                            scope.right_nav.col.news = true;
                            scope.right_nav.col.loc = true;
                        } else if (cl === 'news') {
                            scope.right_nav.col.news = !scope.right_nav.col.news;
                            scope.right_nav.col.art = true;
                            scope.right_nav.col.cat = true;
                            scope.right_nav.col.loc = true;
                        } else {
                            scope.right_nav.col.loc = !scope.right_nav.col.loc;
                            scope.right_nav.col.art = true;
                            scope.right_nav.col.news = true;
                            scope.right_nav.col.cat = true;
                        }

                    };
                    function update(a) {
                        scope.$broadcast('up_news_s', function () {
                            return a;
                        });
                    }
                    scope.right_nav.update = function () {
                        $rootScope.$broadcast('ch_view', function () {
                            return 1;
                        });
                        if (scope.right_nav.updating === false) {
                            if ($routeParams.id !== undefined) {
                                update(0);
                            } else {
                                update(1);
                                scope.right_nav.updating = true;
                            }
                        }
                    };
                    scope.$on('up_news_e', function () {
                        scope.right_nav.updating = false;
                    });
                    scope.$on('manual_geo', function () {
                        scope.right_nav.allow_location();
                    });

                    (function activate() {
                        $rootScope.$broadcast('right_nav', function () {
                            return 1;
                        });
                    }());
                    scope.right_nav.s_class = function () {
                        if (scope.right_nav.filter !== undefined) {
                            if (scope.right_nav.filter.length <= 3) {
                                return '';
                            } else if (scope.right_nav.filter.length > 3) {
                                return 'fa-spin';
                            }
                        } else {
                            return '';
                        }
                    };
                    scope.right_nav.search = function () {
                        $rootScope.$broadcast('filter', function () {
                            return scope.right_nav.filter;
                        });

                    };
                    scope.right_nav.op_src = function () {
                        mm.op_src(scope);
                        $rootScope.$broadcast('filter_m', function () {
                            return 1;
                        });
                    };
                }
            };
        }]);
    app.directive('smnLeftNavBtn', ['menu', 'common_service', 'jQuery', function (menu, common_service, jQuery) {
        return {
            restrict: 'A',
            replace: true,
            controller: function ($scope) {
                $scope.left_btn = {click: false, toggle_left_nav: undefined};
                $scope.left_btn.toggle_left_nav = function () {
                    var btn = jQuery('#left-menu-toggle');
                    if (!btn.hasClass('btn-close')) {
                        btn.children('i').removeClass('fa-align-justify');
                        btn.children('i').addClass('fa-align-right');
                        if (common_service.is_mobile_device() || common_service.is_touch_device()) {
                            jQuery('body').removeClass('hide-overflow');
                        }
                        $scope.left_btn.click = false;

                    } else if (btn.hasClass('btn-close')) {
                        btn.children('i').removeClass('fa-align-right');
                        btn.children('i').addClass('fa-align-justify');
                        if (common_service.is_mobile_device() || common_service.is_touch_device()) {
                            jQuery('body').addClass('hide-overflow');
                        }
                        $scope.left_btn.click = true;
                    }
                    btn.toggleClass('btn-close');
                };
            },
            link: function (scope, elem) {
                if (common_service.is_transform3d()) {
                    elem.click(function (event) {
                        event.stopPropagation();
                        scope.left_btn.toggle_left_nav();
                        menu.toggleLeft();
                    });
                }
            }
        };
    }]);

    app.directive('smnRightNavBtn', ['menu', 'common_service', 'jQuery',
        function (menu, common_service, jQuery) {
            return {
                restrict: 'A',
                replace: true,
                controller: function ($scope) {
                    $scope.right_btn = {click: false, toggle_right_nav: undefined};
                    $scope.right_btn.toggle_right_nav = function () {
                        var btn = jQuery('#right-menu-toggle');
                        if (!btn.hasClass('btn-close')) {
                            btn.children('i').removeClass('fa-gears');
                            btn.children('i').addClass('fa-gear');
                            if (common_service.is_mobile_device() || common_service.is_touch_device()) {
                                jQuery('body').removeClass('hide-overflow');
                            }
                            $scope.right_btn.click = false;
                        } else if (btn.hasClass('btn-close')) {
                            btn.children('i').removeClass('fa-gear');
                            btn.children('i').addClass('fa-gears');
                            if (common_service.is_mobile_device() || common_service.is_touch_device()) {
                                jQuery('body').addClass('hide-overflow');
                            }
                            $scope.right_btn.click = true;

                        }
                        btn.toggleClass('btn-close');
                    };
                },
                link: function (scope, elem) {
                    if (common_service.is_transform3d()) {
                        elem.click(function (event) {
                            event.stopPropagation();
                            scope.right_btn.toggle_right_nav();
                            menu.toggleRight();
                        });
                    }
                }
            };
        }]);

    app.directive('smnSwipeLeft', ['common_service', 'menu',
        function (common_service, menu) {
            return {
                restrict: 'A',
                replace: true,
                link: function (scope, elem) {
                    scope.swipe_left = {swipeRightToOpen: undefined, swipeLeftToClose: undefined};
                    if (common_service.is_mobile_device() || common_service.is_touch_device()) {
                        /*elem.addClass('drag-shadow-left');*/
                    }
                    scope.swipe_left.swipeRightToOpen = function () {
                        if (!scope.left_btn.click) {
                            scope.left_btn.toggle_left_nav();
                            menu.toggleLeft();
                            scope.left_btn.click = true;
                        }
                    };
                    scope.swipe_left.swipeLeftToClose = function () {
                        if (scope.left_btn.click) {
                            scope.left_btn.toggle_left_nav();
                            menu.toggleLeft();
                            scope.left_btn.click = false;
                        }
                    };
                }
            };
        }]);
    app.directive('smnSwipeRight', ['common_service', 'menu',
        function (common_service, menu) {
            return {
                restrict: 'A',
                replace: true,
                link: function (scope, elem) {
                    scope.swipe_right = {swipeLeftToOpen: undefined, swipeRightToClose: undefined};
                    if (common_service.is_mobile_device() || common_service.is_touch_device()) {
                        /*elem.addClass('drag-shadow-right');*/
                    }
                    scope.swipe_right.swipeLeftToOpen = function () {
                        if (!scope.right_btn.click) {
                            scope.right_btn.toggle_right_nav();
                            menu.toggleRight();
                            scope.right_btn.click = true;
                        }
                    };
                    scope.swipe_right.swipeRightToClose = function () {
                        if (scope.right_btn.click) {
                            scope.right_btn.toggle_right_nav();
                            menu.toggleRight();
                            scope.right_btn.click = false;
                        }
                    };
                }
            };
        }]);
}());