(function () {
    'use strict';
    var app = angular.module('smnNg');
    app.directive('smnMainView', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/view/main.html',
                scope: {articles: '=', xopen: '=', hd: '=', xtrim: '='}
            };
        }]);
    app.directive('smnMainViewSecond', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/view/main2.html',
                scope: {articles: '=', xopen: '=', hd: '=', xtrim: '='}
            };
        }]);
    app.directive('smnNewsCoolPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                scope: {articles: '=', xtrim: '=', xopen: '='},
                templateUrl: 'assets/public/directives/news/parts/cool_part.html',
                link: function (scope) {
                    scope.cool_filter = '';
                    scope.$on('filter', function (e, s) {
                        scope.cool_filter = s();
                    });
                }
            };
        }]);
    app.directive('smnNewsCoolView', [function () {
        return {
            restrict: 'A',
            replace: false,
            templateUrl: 'assets/public/directives/news/view/cool.html',
            scope: {articles: '=', xtrim: '=', xopen: '='}
        };
    }]);
    app.directive('smnNewsImgPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/parts/img_part.html',
                scope: {articles: '=', xopen: '='},
                link: function (scope) {
                    scope.img_filter = '';
                    scope.$on('filter', function (e, s) {
                        scope.img_filter = s();
                    });
                }
            };
        }]);
    app.directive('smnNewsImgView', [function () {
        return {
            restrict: 'A',
            replace: false,
            templateUrl: 'assets/public/directives/news/view/img.html',
            scope: {articles: '=', xopen: '='}
        };
    }]);
    app.directive('smnNewsGartPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/parts/gart_part.html',
                scope: {articles: '=', xopen: '=', xtrim: "="},
                link: function (scope) {
                    scope.gart_filter = '';
                    scope.$on('filter', function (e, s) {
                        scope.gart_filter = s();
                    });
                }
            };
        }]);
    app.directive('smnNewsGartView', [function () {
        return {
            restrict: 'A',
            replace: false,
            templateUrl: 'assets/public/directives/news/view/gart.html',
            scope: {articles: '=', xopen: '=', xtrim: "="}
        };
    }]);
    app.directive('smnNewsDetailsPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/parts/detail_part.html',
                scope: {articles: '=', xtrim: "=", xopen: '='},
                link: function (scope) {
                    scope.d_filter = '';
                    scope.$on('filter', function (e, s) {
                        scope.d_filter = s();
                    });
                }
            };
        }]);
    app.directive('smnNewsDetailsView', [function () {
        return {
            restrict: 'A',
            replace: false,
            templateUrl: 'assets/public/directives/news/view/detail.html',
            scope: {articles: '=', xtrim: "=", xopen: '='}
        };
    }]);
    app.directive('smnNewsCarouselPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/parts/carousel.html',
                scope: {hd: '=', xtrim: '=', xopen: '='}
            };
        }]);
    app.directive('smnNewsSpinPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/parts/spin.html'
            };
        }]);
    app.directive('smnNewsLoadingPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/parts/loading.html'
            };
        }]);
    app.directive('smnErrorArticlePage', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/article/error.html'
            };
        }]);
    app.directive('smnArticleModal', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                scope: {art: '=', xbreaks: '=', xtrim: '=', xflag: '='},
                templateUrl: 'assets/public/directives/news/article/modal.html'
            };
        }]);
    app.directive('smnArticleTagsList', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                scope: { tags: '='},
                templateUrl: 'assets/public/directives/news/article/tags.html'
            };
        }]);
    app.directive('smnArticleContent', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                scope: { art: '=', xbreaks: '=', xtrim: '='},
                templateUrl: 'assets/public/directives/news/article/content.html'
            };
        }]);
    app.directive('smnNewsListPart', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/parts/list_part.html',
                scope: {articles: '=', xopen: '='},
                link: function (scope) {
                    scope.li_filter = '';
                    scope.$on('filter', function (e, s) {
                        scope.li_filter = s();
                    });
                }
            };
        }]);
    app.directive('smnNewsListView', [function () {
        return {
            restrict: 'A',
            replace: false,
            templateUrl: 'assets/public/directives/news/view/list.html',
            scope: {articles: '=', xopen: '='}
        };
    }]);
    app.directive('smnArticleRater', [
        function () {
            return {
                restrict: 'A',
                replace: false,
                templateUrl: 'assets/public/directives/news/article/rate.html',
                link: function (s) {
                }
            };
        }]);
    app.directive('smnHideInPage', ['page_manager', function (page_manager) {
        return {
            restrict: 'A',
            replace: true,
            link: function (s, elem) {
                var id = page_manager.page_id();
                if (id !== undefined) {
                    elem.hide();
                }
            }
        };
    }]);
    app.directive('smnModalXStatus', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                link: function (scope, elem) {
                    scope.modal_status = {open: undefined};
                    scope.modal_status.open = function () {
                        elem.modal('show');
                    };
                    scope.$broadcast('status', function () {
                        return 1;
                    });
                    scope.$on('$routeChangeStart', function () {
                        elem.modal('hide');
                    });
                }
            };
        }]);
    app.directive('smnReadArticle', ['news_manager',
        function (news_manager) {
            return {
                restrict: 'A',
                replace: true,
                scope: {axid: '=', xtype: '@'},
                link: function (scope, elem) {
                    function run() {
                        if (news_manager.is_read(scope.axid) === true) {
                            if (scope.xtype === '1') {
                                elem.addClass('fa-check');
                                elem.removeClass('fa-chevron-right');
                            } else if (scope.xtype === '2') {
                                elem.addClass('fa-plus');
                                elem.removeClass('fa-minus');
                            }

                        } else {
                            if (scope.xtype === '1') {
                                elem.addClass('fa-chevron-right');
                            } else if (scope.xtype === '2') {
                                elem.addClass('fa-minus');
                            }
                        }
                    }

                    scope.$on('finally', function () {
                        run();
                    });
                    run();
                }
            };
        }]);
    app.directive('smnArticleModalDialog', [
        function () {
            return {
                restrict: 'A',
                replace: false,
                link: function (scope, elem) {
                    scope.$on('$routeChangeStart', function () {
                        elem.modal('hide');
                    });
                    elem.on('hidden.bs.modal', function () {
                        scope.$broadcast('done', function () {
                            return 0;
                        });
                    });
                }
            };
        }]);
    app.directive('smnArticlePage', ['$rootScope',
        function () {
            return {
                restrict: 'A',
                replace: true,
                scope: {art: '=', xbreaks: '=', xtrim: '=', xflag: '='},
                templateUrl: 'assets/public/directives/news/article/article.html',
                link: function (scope) {
                    scope.xflag = true;
                    scope.$on('$destroy', function () {
                        scope.$broadcast('done', function () {
                            return 1;
                        });
                    });
                }
            };
        }]);
    app.directive('smnNewsCarousel', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                link: function (scope, elem) {
                    angular.element('.swipe-area').addClass('smn-c');
                    elem.carousel({interval: 4000, cycle: true});
                    scope.activeLi = function (index) {
                        return index === 0 ? 'active' : '';
                    };
                    scope.activeIt = function (index) {
                        return index === 0 ? 'item active' : 'item';
                    };
                    scope.prev = function () {
                        elem.carousel('prev');
                    };
                    scope.next = function () {
                        elem.carousel('next');
                    };
                    scope.$on('$destroy', function () {
                        angular.element('.swipe-area').removeClass('smn-c');
                    });
                }
            };
        }]);
    app.directive('smnArticleRatePanel', ['jQuery', 'hotWire', 'news_manager',
        function (jQuery, hotWire, nm) {
            return {
                restrict: 'A',
                replace: true,
                scope: {xaid: '='},
                link: function (scope, elem) {
                    function set_rating(ob, nx) {
                        var allStars = 5,
                            numStars = ob !== undefined ? jQuery(ob).nextUntil().length + 1 : nx,
                            rest = allStars - numStars,
                            i,
                            current,
                            j,
                            f = false,
                            k = 0,
                            es = jQuery('#1');

                        if (numStars === 1 && !es.hasClass('rsx')) {
                            f = true;
                        }
                        for (j = 1; j <= numStars; j++) {
                            jQuery('#' + j).addClass('rsx');
                        }
                        for (i = 5; i > (allStars - rest); i--) {
                            current = jQuery('#' + i);
                            if (current.hasClass('rsx')) {
                                k = (k + 1);
                                current.removeClass('rsx');
                            }
                        }
                        if (numStars === 1 && es.hasClass('rsx') && !f && k === 0) {
                            jQuery('#1').removeClass('rsx');
                            numStars = 0;
                        }

                        hotWire.event.rating = numStars;
                        if (ob !== undefined) {
                            nm.save_rate(scope.xaid, numStars);
                        }

                    }

                    function auto_rate() {
                        var r = nm.get_rate(hotWire.event.article_id), s = elem.attr('id'), i = parseInt(s, 0);
                        if (i <= r) {
                            set_rating(undefined, r);
                        }
                    }

                    auto_rate();
                    elem.on("click", function (event) {
                        event.preventDefault();
                        event.stopPropagation();
                        set_rating(this);
                    });
                    scope.$on('done', function () {
                        elem.removeClass('rsx');
                    });
                    scope.$on('reads', function () {
                        auto_rate();
                    });
                }
            };
        }]);
    app.directive('smnArticleTimer', ['timer_service', '$interval', 'hotWire', '$rootScope',
        function (ts, $interval, hotWire, $rootScope) {
            return {
                restrict: 'A',
                replace: false,
                scope: {xflag: '='},
                link: function (scope, elm) {
                    function start() {
                        scope.startTime = new Date().getTime();
                        hotWire.event.timestamp = scope.startTime;
                        scope.timer = $interval(function () {
                            scope.seconds = (new Date().getTime() - scope.startTime);
                            elm.text(ts.time(scope.seconds));
                            hotWire.event.time_spent = scope.seconds;
                        }, 1000);
                    }

                    function finish() {
                        scope.xflag = false;
                        if (angular.isDefined(scope.timer)) {
                            $interval.cancel(scope.timer);
                        }
                        elm.text('00:00:00');
                        $rootScope.$broadcast('finally', function () {
                            return 1;
                        });
                    }

                    scope.$watch('xflag', function (nval) {
                        if (nval === true) {
                            start();
                        }
                    });
                    scope.$on('done', function () {
                        finish();
                    });
                }
            };
        }]);
    app.directive('smnArticlePrefSize', ['preferences',
        function (pref) {
            return {
                restrict: 'A',
                replace: true,
                scope: {},
                link: function (scope, elem) {
                    function run() {
                        var size = pref.xget_pref();
                        if (size !== undefined && size.fsize !== undefined) {
                            elem.css('font-size', pref.font_pref(size.fsize));
                        }
                    }

                    run();
                    scope.$on('size', function () {
                        run();
                    });
                    scope.$on('user_prefs', function () {
                        run();
                    });
                }
            };
        }]);
    app.directive('smnArticleContentBig', ['preferences', '$rootScope',
        function (pref, $rootScope) {
            return {
                restrict: 'A',
                replace: true,
                scope: {},
                link: function (scope, elem) {
                    scope.c = 0;
                    function change() {
                        var prefs = pref.xget_pref(), t;
                        if (prefs !== undefined && prefs.fsize !== undefined && prefs.fsize < 8) {
                            t = prefs.fsize;
                            t = (t + 1);
                            prefs.fsize = t;
                            pref.xset_pref(prefs);
                            $rootScope.$broadcast('size', function () {
                                return 1;
                            });
                            scope.c = scope.c + 1;
                        }
                    }

                    elem.on('click', function () {
                        change();
                    });
                    scope.$watch('c', function () {
                    });
                    scope.$on('user_prefs', function () {
                        change();
                    });
                }
            };
        }]);
    app.directive('smnArticleContentSmall', ['$rootScope', 'preferences',
        function ($rootScope, pref) {
            return {
                restrict: 'A',
                replace: false,
                scope: {},
                link: function (scope, elem, attrs) {
                    scope.c = 0;
                    function change() {
                        var prefs = pref.xget_pref(), t;
                        if (prefs !== undefined && prefs.fsize !== undefined && prefs.fsize > 1) {
                            t = prefs.fsize;
                            t = (t - 1);
                            prefs.fsize = t;
                            pref.xset_pref(prefs);
                            $rootScope.$broadcast('size', function () {
                                return 1;
                            });
                            scope.c = scope.c + 1;
                        }
                    }

                    elem.on('click', function () {
                        change();
                    });
                    scope.$watch('c', function () { });
                    scope.$on('user_prefs', function () {
                        change();
                    });
                }
            };
        }]);
    app.directive('smnArticleBgChanger', ['preferences', '$rootScope',
        function (pref, $rootScope) {
            return {
                restrict: 'A',
                replace: true,
                link: function (scope, elem) {
                    function change() {
                        var prefs = pref.xget_pref();
                        if (prefs !== undefined && prefs.bcolor !== undefined) {
                            if ((prefs.bcolor === 1)) {
                                prefs.bcolor = 2;
                            } else if (prefs.bcolor === 2) {
                                prefs.bcolor = 3;
                            } else if (prefs.bcolor === 3) {
                                prefs.bcolor = 4;
                            } else if (prefs.bcolor === 4) {
                                prefs.bcolor = 5;
                            } else if (prefs.bcolor === 5) {
                                prefs.bcolor = 1;
                            }
                            pref.xset_pref(prefs);
                            $rootScope.$broadcast('color', function () {
                                return 1;
                            });
                        }
                    }

                    elem.on('click', function () {
                        change();
                    });
                    scope.$on('user_prefs', function () {
                        change();
                    });
                }
            };
        }]);
    app.directive('smnArticlePrefColor', ['preferences', 'Math',
        function (pref) {
            return {
                restrict: 'A',
                replace: true,
                scope: {ctype: '='},
                link: function (scope, elem) {
                    function removeAll() {
                        elem.removeClass('xa-a xa-b xa-c xa-d xa-e');
                    }

                    function run() {
                        var prefs = pref.xget_pref();
                        if (prefs !== undefined && prefs.bcolor !== undefined) {
                            if ((prefs.bcolor === 1)) {
                                removeAll();
                                elem.addClass('xa-a');
                            } else if (prefs.bcolor === 2) {
                                removeAll();
                                elem.addClass('xa-b');
                            } else if (prefs.bcolor === 3) {
                                removeAll();
                                elem.addClass('xa-c');
                            } else if (prefs.bcolor === 4) {
                                removeAll();
                                elem.addClass('xa-d');
                            } else if (prefs.bcolor === 5) {
                                removeAll();
                                elem.addClass('xa-e');
                            }
                        }
                    }

                    run();
                    scope.$on('color', function () {
                        run();
                    });
                    scope.$on('user_prefs', function () {
                        run();
                    });
                }
            };
        }]);
    app.directive('smnShareArticle', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/article/share.html'
            };
        }]);
    app.directive('smnTwitterShare', ['page_manager', 'hotWire', function (pm, hw) {
        return {
            restrict: 'A',
            replace: true,
            template: '<i class="fa fa-twitter-square fa-3x twitter smn-time pointer" data-smn-scale-that data-text="Smart media news"></i>',
            link: function (s, elem) {
                elem.sharrre({
                    share: {
                        twitter: true
                    },
                    enableHover: false,
                    enableCounter: false,
                    template: '<div></div>',
                    click: function (api, options) {
                        options.url = pm.share_link(hw.event.article_id);
                        api.simulateClick();
                        api.openPopup('twitter');
                    }
                });
            }
        };
    }]);
    app.directive('smnLinkedInShare', ['page_manager', 'hotWire', function (pm, hw) {
        return {
            restrict: 'A',
            replace: true,
            template: '<i class="fa fa-linkedin-square fa-3x linkedin smn-time pointer" data-smn-scale-that data-text="Smart media news"></i>',
            link: function (s, elem) {
                elem.sharrre({
                    share: {
                        linkedin: true
                    },
                    enableHover: false,
                    enableCounter: false,
                    template: '<div></div>',
                    click: function (api, options) {
                        options.url = pm.share_link(hw.event.article_id);
                        api.simulateClick();
                        api.openPopup('linkedin');
                    }
                });
            }
        };
    }]);
    app.directive('smnGooglePlusShare', ['page_manager', 'hotWire', function (pm, hw) {
        return {
            restrict: 'A',
            replace: true,
            template: '<i class="fa fa-google-plus-square fa-3x googleplus smn-time pointer" data-smn-scale-that data-text="Smart media news"></i>',
            link: function (s, elem) {
                elem.sharrre({
                    share: {
                        googlePlus: true
                    },
                    enableHover: false,
                    enableCounter: false,
                    template: '<div></div>',
                    click: function (api, options) {
                        options.buttons.googlePlus.url = pm.share_link(hw.event.article_id);
                        api.simulateClick();
                        api.openPopup('googlePlus');
                    }
                });
            }
        };
    }]);
    app.directive('smnFacebookShare', ['page_manager', 'hotWire', function (pm, hw) {
        return {
            restrict: 'A',
            replace: true,
            template: '<i class="fa fa-facebook-square fa-3x facebook smn-time pointer" data-smn-scale-that data-text="Smart media news""></i>',
            link: function (s, elem) {
                elem.sharrre({
                    share: {
                        facebook: true
                    },
                    enableHover: false,
                    enableCounter: false,
                    template: '<div></div>',
                    click: function (api, options) {
                        options.buttons.facebook.url = pm.share_link(hw.event.article_id);
                        api.simulateClick();
                        api.openPopup('facebook');
                    }
                });
            }
        };
    }]);
    app.directive('smnArticlePanel', [
        function () {
            return {
                restrict: 'A',
                replace: true,
                templateUrl: 'assets/public/directives/news/article/panel.html',
                scope: {xflag: '=', xaid: '=', art: '='},
                link: function (scope) {
                    function reset() {
                        scope.one = scope.two = scope.three = true;
                        scope.four = false;
                    }

                    reset();
                    scope.$on('done', function () {
                        reset();
                    });
                    scope.$on('reads', function () {
                        scope.four = true;
                    });
                    scope.$on('map_ready', function (e, s) {
                        var a = s();
                        if (a === 0) {
                            scope.four = true;
                        }
                    });
                    scope.$on('get_location', function () {
                        scope.four = false;
                    });
                }
            };
        }]);
    app.directive('smnGoogleMap', ['$rootScope', function ($rootScope) {
        return {
            restrict: 'A',
            replace: true,
            templateUrl: 'assets/public/directives/news/article/map.html',
            link: function (scope) {
                scope.turn_geo = function () {
                    $rootScope.$broadcast('manual_geo', function () {
                        return 1;
                    });
                };
            }
        };
    }]);
    app.directive('smnMapPart', ['$rootScope', 'preferences', 'hotWire', function ($rootScope, prefs, hw) {
        return {
            restrict: 'A',
            replace: true,
            templateUrl: 'assets/public/directives/news/parts/map_part.html',
            scope: { articles: '=', showart: '='},
            controller: function ($scope) {
                $scope.map_ctrl = {};
                $scope.markers = [];
                $scope.set_marker = function (m) {
                    m.i = 'assets/img/site/default/home.png';
                };
                angular.forEach($scope.articles, function (v) {
                    if (v.geo !== undefined && v.geo.length > 0) {
                        angular.forEach(v.geo, function (vg) {
                            angular.forEach(vg, function (vl) {
                                $scope.markers.push(
                                    {   cl: function () {
                                        $scope.showart(this.model.options.a, true);
                                    },
                                        svl: false,
                                        url: 'assets/public/directives/news/parts/map_label.html',
                                        c: {latitude: vl[0], longitude: vl[1]},
                                        events: $scope.events,
                                        options: {
                                            title: v.src.title + ':\n' + v.src.leadText,
                                            a: v
                                        }
                                    }
                                );
                            });
                        });
                    }
                });
                function user_loc() {
                    var loc = prefs.get_geo();
                    if (loc !== undefined) {
                        $scope.markers.push(
                            {i: 'assets/img/site/default/home.png',
                                c: {latitude: loc.latitude, longitude: loc.longitude },
                                sw: false, title: 'ME',
                                anchor: {x: 10, y: 10}}
                        );
                    }
                }

                user_loc();
                $scope.center = { latitude: 13.440227,
                    longitude: 22.450947};
                $scope.zoom = 3;
                $scope.icon = '';
                $scope.bounds = { northeast: {latitude: 2.5404, longitude: -3.0928}, southwest: {latitude: 4.8863, longitude: -15.0264}};
                $scope.pan = false;
                $scope.anchor = {x: 10, y: 10};
                $scope.options = {
                    disableDefaultUI: true,
                    draggable: true,
                    minZoom: 3
                    /*zoomControl: false,
                     scrollwheel: false,
                     scaleControl: false,
                     rotateControl: false,
                     panControl: false,
                     mapTypeControl: false,
                     overviewMapControl: false,
                     backgroundColor: 'red'*/
                };
                $scope.$on('delete_geo', function () {
                    $scope.markers.pop();
                });
                $scope.$on('location_on', function () {
                    user_loc();
                });
            }
        };
    }]);
    app.directive('smnNewsMapView', [function () {
        return {
            restrict: 'A',
            replace: true,
            templateUrl: 'assets/public/directives/news/view/world.html',
            scope: {articles: '=', xopen: '='}
        };
    }]);
    app.directive('smnSetSearch', ['$timeout', function ($timeout) {
        return {
            restrict: 'A',
            replace: false,
            link: function (scope, elem) {
                scope.$on('filter_m', function () {
                    $timeout(function () {
                        elem.focus();
                    }, 2000);
                });
            }
        };
    }]);
}());
